  ; Exportiert PROCEDURE ChoicerGet  VAR_BOOL CG.ViewIt,
  ;                                  VAR_STR  CG.MaskName,
  ;                                  VAR_STR  CG.VarName,
  ;                                  VAR_STR  CG.VarNameView,
  ;                                  VAR_NUM  CG.ChoicerList,
  ;                                  VAR_STR  CG.ChoicerField,
  ;                                  VAR_STR  CG.HeaderField,
  ;                                  VAR_NUM  CG.HeaderWidth,
  ;                                  VAR_STR  CG.HeaderName,
  ;                                  VAR_STR  CG.ViewHeader,
  ;                                 ~VAR_BOOL CG.Result

  ; CG.ViewIt       : Soll die Liste zur Auswahl gezeigt werden (TRUE),  soll der Wert nur geholt werden (FALSE)
  ; CG.MaskName     : falls die Variable [VarName] zu einer Maske gehrt, ist hierin der Maskenname unterzubringen
  ; CG.VarName      : Name der Variable die mit dem Choicer - Ergebnis zu fllen ist
  ;                   Wenn ein Choicer Verzweigungen hat (Eventflag der gewhlten Zeile verweist auf einen weiteren
  ;                   Choicer) dann stehen in dieser Variable alle Listennummern und RecordID's mit Komma getrennt,
  ;                   der Choicer-Zeilen, die gewhlt wurden. Diese Variable sollte dann auf keinen Fall ein
  ;                   Masken-Feld bezeichnen. Es drfen maximal 10 Verzweigungstiefen verwendet werden.
  ;                   Die (Script)-Variable [CG.MultiSelect] ist in einem solchen Fall TRUE - bei normalen, einfachen
  ;                   Choicer-Selects (ohne Verzweigung) ist Multi-Select FALSE.
  ; CG.VarNameView  : Name der Variable die mit dem Feld des Choicers zu fllen ist, das angezeigt wird (kann leer sein)
  ; CG.ChocierList  : Nummer der Liste, die gezeigt werden soll
  ; CG.ChocierField : Name des Feldes in der Choicer-Tabelle, das geladen werden soll
  ; CG.HeaderField  : Name des Feldes in der Choicer-Tabelle, das als berschgriftverwendet werden soll
  ; CG.HeaderWidth  : Breite mit der das HeaderField der Choicer-Tabelle angezeigt werden soll
  ; CG.HeaderName   : Name der im Browser angezeigt werden soll (anstelle HeaderField wie z.B. WERT1, WERT2 etc.)
  ;                   Wenn hier mit Pipe getrennet ("|") ein Feld genannt wird, wird die Auswahl-Liste danach sortiert
  ;                   und man kann die Schnellsuche verwenden.
  ; CG.ViewHeader   : Falls ein View durchgefhrt werden soll, sollte hier die berschrift des Browserfensters stehen
  ; CG.Result       : TRUE wenn alles geklappt hat und FALSE wenn nicht


  PROCEDURE ChoicerInsert
    SCRIPT 'CHOICER.CSH',[CG.Q1!RecordID]
    QUERY_REFRESH [CG.Q1]
    CALC [CG.Q1!VIEW_ACTION] AS 1
  END_PROC


  PROCEDURE ChoicerSubSelect10
    IF [CSS09.Q1!EventFlag]>0
      LOCAL_BOOL    CSS10.VarExists
      LOCAL_BOOL    CSS10.QRes1
      LOCAL_NUM     CSS10.VarType
      LOCAL_NUM     CSS10.VarRoot
      LOCAL_STR     CSS10.ViewHeader
      LOCAL_STR     CSS10.TmpStr
      LOCAL_FLOAT   CSS10.TmpFloat

      IDENTIFIER_EXIST 'CSS10.Q1',[CSS10.VarExists],[CSS10.VarRoot],[CSS10.VarType]
      IF [CSS10.VarExists]=FALSE
        VAR_BROWSER CSS10.Q1
      END_IF

      QUERY [CSS10.Q1]
          SELECT Auswahl
            FROM Choicer
           WHERE ListeNummer = [CSS09.Q1!EventFlag]
             AND Sortierung = 0
        ORDER BY ListeNummer, Sortierung
      END_QUERY
      EXECUTE  [CSS10.Q1],[CSS10.QRes1]
      IF [CSS10.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln der Unterlisten-berschrift (10) konnte nicht bersetzt werden'
        CALC [CSS09.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      GET_DATA [CSS10.Q1],[CSS10.QRes1]
      IF [CSS10.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Unterlisten-berschrift (10) konnte nicht gelesen werden'
        CALC [CSS09.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      CALC [CSS10.ViewHeader] AS [CSS10.Q1!Auswahl]

      QUERY_LOAD [CSS10.Q1],[CSS10.QRes1],'CH_SUB10'
      IF [CSS10.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Eine Unterlisten-Abfrage (10) konnte nicht geladen werden'
        CALC [CSS09.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF

      IF [CSS10.SubRes]<>''
        CALC [CSS10.TmpStr] AS PART([CSS10.SubRes],2,';')
        IF [CSS10.TmpStr]<>''
          CALC [CSS10.TmpFloat]  AS VAL([CSS10.TmpStr])
          IF [CSS10.TmpFloat]>[EPSILON]
            CALC [CSS10.TmpStr] AS CON('STARTING WITH RecordID = ',[CSS10.TmpFloat|R0,0])
            QUERY_ADD_STRING [CSS10.Q1], [CSS10.TmpStr]
          ELSE
            CALC [CSS10.TmpStr] AS ''
          END_IF
        END_IF
      END_IF

      VIEW [CSS10.Q1],[CSS10.QRes1],[CSS10.ViewHeader]

      IF [CSS09.QRes1]=FALSE
        CALC [CSS10.SubRes]   AS CON([CSS09.Q1!EventFlag],';',[CSS10.Q1!RecordID|R0,0])
        CALC [CG.MultiSelect] AS TRUE
      ELSE
        CALC [CSS09.SubRes] AS CON([CSS08.Q1!EventFlag],';',[CSS09.Q1!RecordID|R0,0])
        CALC [CSS09.Q1!VIEW_ACTION] AS 1
      END_IF
    ELSE
      CALC [CSS09.SubRes]   AS CON([CSS08.Q1!EventFlag],';',[CSS09.Q1!RecordID|R0,0])
      CALC [CG.MultiSelect] AS TRUE
    END_IF
  END_PROC


  PROCEDURE ChoicerSubSelect09
    IF [CSS08.Q1!EventFlag]>0
      LOCAL_BOOL    CSS09.VarExists
      LOCAL_BOOL    CSS09.QRes1
      LOCAL_NUM     CSS09.VarType
      LOCAL_NUM     CSS09.VarRoot
      LOCAL_STR     CSS09.ViewHeader
      LOCAL_STR     CSS09.TmpStr
      LOCAL_FLOAT   CSS09.TmpFloat

      IDENTIFIER_EXIST 'CSS09.Q1',[CSS09.VarExists],[CSS09.VarRoot],[CSS09.VarType]
      IF [CSS09.VarExists]=FALSE
        VAR_BROWSER CSS09.Q1
      END_IF

      QUERY [CSS09.Q1]
          SELECT Auswahl
            FROM Choicer
           WHERE ListeNummer = [CSS08.Q1!EventFlag]
             AND Sortierung = 0
        ORDER BY ListeNummer, Sortierung
      END_QUERY
      EXECUTE  [CSS09.Q1],[CSS09.QRes1]
      IF [CSS09.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln der Unterlisten-berschrift (09) konnte nicht bersetzt werden'
        CALC [CSS08.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      GET_DATA [CSS09.Q1],[CSS09.QRes1]
      IF [CSS09.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Unterlisten-berschrift (09) konnte nicht gelesen werden'
        CALC [CSS08.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      CALC [CSS09.ViewHeader] AS [CSS09.Q1!Auswahl]

      QUERY_LOAD [CSS09.Q1],[CSS09.QRes1],'CH_SUB09'
      IF [CSS09.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Eine Unterlisten-Abfrage (09) konnte nicht geladen werden'
        CALC [CSS08.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF

      IF [CSS09.SubRes]<>''
        CALC [CSS09.TmpStr] AS PART([CSS09.SubRes],2,';')
        IF [CSS09.TmpStr]<>''
          CALC [CSS09.TmpFloat]  AS VAL([CSS09.TmpStr])
          IF [CSS09.TmpFloat]>[EPSILON]
            CALC [CSS09.TmpStr] AS CON('STARTING WITH RecordID = ',[CSS09.TmpFloat|R0,0])
            QUERY_ADD_STRING [CSS09.Q1], [CSS09.TmpStr]
          ELSE
            CALC [CSS09.TmpStr] AS ''
          END_IF
        END_IF

        IF [CSS09.TmpStr]<>''
          IF [CSS10.SubRes]<>''
            FLAG_SET [CSS09.Q1!VIEW_FLAG],[BROWSER_FLAG_OK_ON_STARTING]
          END_IF
        END_IF
      END_IF

      CALC [CSS09.Q1!BROWSER_HOOK_OK] AS 'ChoicerSubSelect10'
      VIEW [CSS09.Q1],[CSS09.QRes1],[CSS09.ViewHeader]

      IF [CG.MultiSelect]=FALSE
        CALC [CSS08.Q1!VIEW_ACTION] AS 1
      ELSE
        CALC [CSS08.SubRes] AS CON([CSS07.Q1!EventFlag],';',[CSS08.Q1!RecordID|R0,0])
      END_IF
    ELSE
      CALC [CSS08.SubRes]   AS CON([CSS07.Q1!EventFlag],';',[CSS08.Q1!RecordID|R0,0])
      CALC [CG.MultiSelect] AS TRUE
    END_IF
  END_PROC


  PROCEDURE ChoicerSubSelect08
    IF [CSS07.Q1!EventFlag]>0
      LOCAL_BOOL    CSS08.VarExists
      LOCAL_BOOL    CSS08.QRes1
      LOCAL_NUM     CSS08.VarType
      LOCAL_NUM     CSS08.VarRoot
      LOCAL_STR     CSS08.ViewHeader
      LOCAL_STR     CSS08.TmpStr
      LOCAL_FLOAT   CSS08.TmpFloat

      IDENTIFIER_EXIST 'CSS08.Q1',[CSS08.VarExists],[CSS08.VarRoot],[CSS08.VarType]
      IF [CSS08.VarExists]=FALSE
        VAR_BROWSER CSS08.Q1
      END_IF

      QUERY [CSS08.Q1]
          SELECT Auswahl
            FROM Choicer
           WHERE ListeNummer = [CSS07.Q1!EventFlag]
             AND Sortierung = 0
        ORDER BY ListeNummer, Sortierung
      END_QUERY
      EXECUTE  [CSS08.Q1],[CSS08.QRes1]
      IF [CSS08.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln der Unterlisten-berschrift (08) konnte nicht bersetzt werden'
        CALC [CSS07.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      GET_DATA [CSS08.Q1],[CSS08.QRes1]
      IF [CSS08.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Unterlisten-berschrift (08) konnte nicht gelesen werden'
        CALC [CSS07.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      CALC [CSS08.ViewHeader] AS [CSS08.Q1!Auswahl]

      QUERY_LOAD [CSS08.Q1],[CSS08.QRes1],'CH_SUB08'
      IF [CSS08.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Eine Unterlisten-Abfrage (08) konnte nicht geladen werden'
        CALC [CSS07.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF

      IF [CSS08.SubRes]<>''
        CALC [CSS08.TmpStr] AS PART([CSS08.SubRes],2,';')
        IF [CSS08.TmpStr]<>''
          CALC [CSS08.TmpFloat]  AS VAL([CSS08.TmpStr])
          IF [CSS08.TmpFloat]>[EPSILON]
            CALC [CSS08.TmpStr] AS CON('STARTING WITH RecordID = ',[CSS08.TmpFloat|R0,0])
            QUERY_ADD_STRING [CSS08.Q1], [CSS08.TmpStr]
          ELSE
            CALC [CSS08.TmpStr] AS ''
          END_IF
        END_IF

        IF [CSS08.TmpStr]<>''
          IF [CSS09.SubRes]<>''
            FLAG_SET [CSS08.Q1!VIEW_FLAG],[BROWSER_FLAG_OK_ON_STARTING]
          END_IF
        END_IF
      END_IF

      CALC [CSS08.Q1!BROWSER_HOOK_OK] AS 'ChoicerSubSelect09'
      VIEW [CSS08.Q1],[CSS08.QRes1],[CSS08.ViewHeader]

      IF [CG.MultiSelect]=FALSE
        CALC [CSS07.Q1!VIEW_ACTION] AS 1
      ELSE
        CALC [CSS07.SubRes] AS CON([CSS06.Q1!EventFlag],';',[CSS07.Q1!RecordID|R0,0])
      END_IF
    ELSE
      CALC [CSS07.SubRes]   AS CON([CSS06.Q1!EventFlag],';',[CSS07.Q1!RecordID|R0,0])
      CALC [CG.MultiSelect] AS TRUE
    END_IF
  END_PROC


  PROCEDURE ChoicerSubSelect07
    IF [CSS06.Q1!EventFlag]>0
      LOCAL_BOOL    CSS07.VarExists
      LOCAL_BOOL    CSS07.QRes1
      LOCAL_NUM     CSS07.VarType
      LOCAL_NUM     CSS07.VarRoot
      LOCAL_STR     CSS07.ViewHeader
      LOCAL_STR     CSS07.TmpStr
      LOCAL_FLOAT   CSS07.TmpFloat

      IDENTIFIER_EXIST 'CSS07.Q1',[CSS07.VarExists],[CSS07.VarRoot],[CSS07.VarType]
      IF [CSS07.VarExists]=FALSE
        VAR_BROWSER CSS07.Q1
      END_IF

      QUERY [CSS07.Q1]
          SELECT Auswahl
            FROM Choicer
           WHERE ListeNummer = [CSS06.Q1!EventFlag]
             AND Sortierung = 0
        ORDER BY ListeNummer, Sortierung
      END_QUERY
      EXECUTE  [CSS07.Q1],[CSS07.QRes1]
      IF [CSS07.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln der Unterlisten-berschrift (07) konnte nicht bersetzt werden'
        CALC [CSS06.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      GET_DATA [CSS07.Q1],[CSS07.QRes1]
      IF [CSS07.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Unterlisten-berschrift (07) konnte nicht gelesen werden'
        CALC [CSS06.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      CALC [CSS07.ViewHeader] AS [CSS07.Q1!Auswahl]

      QUERY_LOAD [CSS07.Q1],[CSS07.QRes1],'CH_SUB07'
      IF [CSS07.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Eine Unterlisten-Abfrage (07) konnte nicht geladen werden'
        CALC [CSS06.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF

      IF [CSS07.SubRes]<>''
        CALC [CSS07.TmpStr] AS PART([CSS07.SubRes],2,';')
        IF [CSS07.TmpStr]<>''
          CALC [CSS07.TmpFloat]  AS VAL([CSS07.TmpStr])
          IF [CSS07.TmpFloat]>[EPSILON]
            CALC [CSS07.TmpStr] AS CON('STARTING WITH RecordID = ',[CSS07.TmpFloat|R0,0])
            QUERY_ADD_STRING [CSS07.Q1], [CSS07.TmpStr]
          ELSE
            CALC [CSS07.TmpStr] AS ''
          END_IF
        END_IF

        IF [CSS07.TmpStr]<>''
          IF [CSS08.SubRes]<>''
            FLAG_SET [CSS07.Q1!VIEW_FLAG],[BROWSER_FLAG_OK_ON_STARTING]
          END_IF
        END_IF
      END_IF

      CALC [CSS07.Q1!BROWSER_HOOK_OK] AS 'ChoicerSubSelect08'
      VIEW [CSS07.Q1],[CSS07.QRes1],[CSS07.ViewHeader]

      IF [CG.MultiSelect]=FALSE
        CALC [CSS06.Q1!VIEW_ACTION] AS 1
      ELSE
        CALC [CSS06.SubRes] AS CON([CSS05.Q1!EventFlag],';',[CSS06.Q1!RecordID|R0,0])
      END_IF
    ELSE
      CALC [CSS06.SubRes]   AS CON([CSS05.Q1!EventFlag],';',[CSS06.Q1!RecordID|R0,0])
      CALC [CG.MultiSelect] AS TRUE
    END_IF
  END_PROC


  PROCEDURE ChoicerSubSelect06
    IF [CSS05.Q1!EventFlag]>0
      LOCAL_BOOL    CSS06.VarExists
      LOCAL_BOOL    CSS06.QRes1
      LOCAL_NUM     CSS06.VarType
      LOCAL_NUM     CSS06.VarRoot
      LOCAL_STR     CSS06.ViewHeader
      LOCAL_STR     CSS06.TmpStr
      LOCAL_FLOAT   CSS06.TmpFloat

      IDENTIFIER_EXIST 'CSS06.Q1',[CSS06.VarExists],[CSS06.VarRoot],[CSS06.VarType]
      IF [CSS06.VarExists]=FALSE
        VAR_BROWSER CSS06.Q1
      END_IF

      QUERY [CSS06.Q1]
          SELECT Auswahl
            FROM Choicer
           WHERE ListeNummer = [CSS05.Q1!EventFlag]
             AND Sortierung = 0
        ORDER BY ListeNummer, Sortierung
      END_QUERY
      EXECUTE  [CSS06.Q1],[CSS06.QRes1]
      IF [CSS06.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln der Unterlisten-berschrift (06) konnte nicht bersetzt werden'
        CALC [CSS05.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      GET_DATA [CSS06.Q1],[CSS06.QRes1]
      IF [CSS06.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Unterlisten-berschrift (06) konnte nicht gelesen werden'
        CALC [CSS05.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      CALC [CSS06.ViewHeader] AS [CSS06.Q1!Auswahl]


      QUERY_LOAD [CSS06.Q1],[CSS05.QRes1],'CH_SUB06'
      IF [CSS06.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Eine Unterlisten-Abfrage (06) konnte nicht geladen werden'
        CALC [CSS05.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF

      IF [CSS06.SubRes]<>''
        CALC [CSS06.TmpStr] AS PART([CSS06.SubRes],2,';')
        IF [CSS06.TmpStr]<>''
          CALC [CSS06.TmpFloat]  AS VAL([CSS06.TmpStr])
          IF [CSS06.TmpFloat]>[EPSILON]
            CALC [CSS06.TmpStr] AS CON('STARTING WITH RecordID = ',[CSS06.TmpFloat|R0,0])
            QUERY_ADD_STRING [CSS06.Q1], [CSS06.TmpStr]
          ELSE
            CALC [CSS06.TmpStr] AS ''
          END_IF
        END_IF

        IF [CSS06.TmpStr]<>''
          IF [CSS07.SubRes]<>''
            FLAG_SET [CSS06.Q1!VIEW_FLAG],[BROWSER_FLAG_OK_ON_STARTING]
          END_IF
        END_IF
      END_IF

      CALC [CSS06.Q1!BROWSER_HOOK_OK] AS 'ChoicerSubSelect07'
      VIEW [CSS06.Q1],[CSS06.QRes1],[CSS06.ViewHeader]

      IF [CG.MultiSelect]=FALSE
        CALC [CSS05.Q1!VIEW_ACTION] AS 1
      ELSE
        CALC [CSS05.SubRes] AS CON([CSS04.Q1!EventFlag],';',[CSS05.Q1!RecordID|R0,0])
      END_IF
    ELSE
      CALC [CSS05.SubRes]   AS CON([CSS04.Q1!EventFlag],';',[CSS05.Q1!RecordID|R0,0])
      CALC [CG.MultiSelect] AS TRUE
    END_IF
  END_PROC


  PROCEDURE ChoicerSubSelect05
    IF [CSS04.Q1!EventFlag]>0
      LOCAL_BOOL    CSS05.VarExists
      LOCAL_BOOL    CSS05.QRes1
      LOCAL_NUM     CSS05.VarType
      LOCAL_NUM     CSS05.VarRoot
      LOCAL_STR     CSS05.ViewHeader
      LOCAL_STR     CSS05.TmpStr
      LOCAL_FLOAT   CSS05.TmpFloat

      IDENTIFIER_EXIST 'CSS05.Q1',[CSS05.VarExists],[CSS05.VarRoot],[CSS05.VarType]
      IF [CSS05.VarExists]=FALSE
        VAR_BROWSER CSS05.Q1
      END_IF

      QUERY [CSS05.Q1]
          SELECT Auswahl
            FROM Choicer
           WHERE ListeNummer = [CSS04.Q1!EventFlag]
             AND Sortierung = 0
        ORDER BY ListeNummer, Sortierung
      END_QUERY
      EXECUTE  [CSS05.Q1],[CSS05.QRes1]
      IF [CSS05.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln der Unterlisten-berschrift (05) konnte nicht bersetzt werden'
        CALC [CSS04.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      GET_DATA [CSS05.Q1],[CSS05.QRes1]
      IF [CSS05.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Unterlisten-berschrift (05) konnte nicht gelesen werden'
        CALC [CSS04.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      CALC [CSS05.ViewHeader] AS [CSS05.Q1!Auswahl]


      QUERY_LOAD [CSS05.Q1],[CSS05.QRes1],'CH_SUB05'
      IF [CSS05.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Eine Unterlisten-Abfrage (05) konnte nicht geladen werden'
        CALC [CSS04.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF

      IF [CSS05.SubRes]<>''
        CALC [CSS05.TmpStr] AS PART([CSS05.SubRes],2,';')
        IF [CSS05.TmpStr]<>''
          CALC [CSS05.TmpFloat]  AS VAL([CSS05.TmpStr])
          IF [CSS05.TmpFloat]>[EPSILON]
            CALC [CSS05.TmpStr] AS CON('STARTING WITH RecordID = ',[CSS05.TmpFloat|R0,0])
            QUERY_ADD_STRING [CSS05.Q1], [CSS05.TmpStr]
          ELSE
            CALC [CSS05.TmpStr] AS ''
          END_IF
        END_IF

        IF [CSS05.TmpStr]<>''
          IF [CSS06.SubRes]<>''
            FLAG_SET [CSS05.Q1!VIEW_FLAG],[BROWSER_FLAG_OK_ON_STARTING]
          END_IF
        END_IF
      END_IF

      CALC [CSS05.Q1!BROWSER_HOOK_OK] AS 'ChoicerSubSelect06'
      VIEW [CSS05.Q1],[CSS05.QRes1],[CSS05.ViewHeader]

      IF [CG.MultiSelect]=FALSE
        CALC [CSS04.Q1!VIEW_ACTION] AS 1
      ELSE
        CALC [CSS04.SubRes] AS CON([CSS03.Q1!EventFlag],';',[CSS04.Q1!RecordID|R0,0])
      END_IF
    ELSE
      CALC [CSS04.SubRes]   AS CON([CSS03.Q1!EventFlag],';',[CSS04.Q1!RecordID|R0,0])
      CALC [CG.MultiSelect] AS TRUE
    END_IF
  END_PROC


  PROCEDURE ChoicerSubSelect04
    IF [CSS03.Q1!EventFlag]>0
      LOCAL_BOOL    CSS04.VarExists
      LOCAL_BOOL    CSS04.QRes1
      LOCAL_NUM     CSS04.VarType
      LOCAL_NUM     CSS04.VarRoot
      LOCAL_STR     CSS04.ViewHeader
      LOCAL_STR     CSS04.TmpStr
      LOCAL_FLOAT   CSS04.TmpFloat

      IDENTIFIER_EXIST 'CSS04.Q1',[CSS04.VarExists],[CSS04.VarRoot],[CSS04.VarType]
      IF [CSS04.VarExists]=FALSE
        VAR_BROWSER CSS04.Q1
      END_IF

      QUERY [CSS04.Q1]
          SELECT Auswahl
            FROM Choicer
           WHERE ListeNummer = [CSS03.Q1!EventFlag]
             AND Sortierung = 0
        ORDER BY ListeNummer, Sortierung
      END_QUERY
      EXECUTE  [CSS04.Q1],[CSS04.QRes1]
      IF [CSS04.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln der Unterlisten-berschrift (04) konnte nicht bersetzt werden'
        CALC [CSS03.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      GET_DATA [CSS04.Q1],[CSS04.QRes1]
      IF [CSS04.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Unterlisten-berschrift (04) konnte nicht gelesen werden'
        CALC [CSS03.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      CALC [CSS04.ViewHeader] AS [CSS04.Q1!Auswahl]


      QUERY_LOAD [CSS04.Q1],[CSS04.QRes1],'CH_SUB04'
      IF [CSS04.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Eine Unterlisten-Abfrage (04) konnte nicht geladen werden'
        CALC [CSS03.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF

      IF [CSS04.SubRes]<>''
        CALC [CSS04.TmpStr] AS PART([CSS04.SubRes],2,';')
        IF [CSS04.TmpStr]<>''
          CALC [CSS04.TmpFloat]  AS VAL([CSS04.TmpStr])
          IF [CSS04.TmpFloat]>[EPSILON]
            CALC [CSS04.TmpStr] AS CON('STARTING WITH RecordID = ',[CSS04.TmpFloat|R0,0])
            QUERY_ADD_STRING [CSS04.Q1], [CSS04.TmpStr]
          ELSE
            CALC [CSS04.TmpStr] AS ''
          END_IF
        END_IF

        IF [CSS04.TmpStr]<>''
          IF [CSS05.SubRes]<>''
            FLAG_SET [CSS04.Q1!VIEW_FLAG],[BROWSER_FLAG_OK_ON_STARTING]
          END_IF
        END_IF
      END_IF

      CALC [CSS04.Q1!BROWSER_HOOK_OK] AS 'ChoicerSubSelect05'
      VIEW [CSS04.Q1],[CSS04.QRes1],[CSS04.ViewHeader]

      IF [CG.MultiSelect]=FALSE
        CALC [CSS03.Q1!VIEW_ACTION] AS 1
      ELSE
        CALC [CSS03.SubRes] AS CON([CSS02.Q1!EventFlag],';',[CSS03.Q1!RecordID|R0,0])
      END_IF
    ELSE
      CALC [CSS03.SubRes]   AS CON([CSS02.Q1!EventFlag],';',[CSS03.Q1!RecordID|R0,0])
      CALC [CG.MultiSelect] AS TRUE
    END_IF
  END_PROC


  PROCEDURE ChoicerSubSelect03
    IF [CSS02.Q1!EventFlag]>0
      LOCAL_BOOL    CSS03.VarExists
      LOCAL_BOOL    CSS03.QRes1
      LOCAL_NUM     CSS03.VarType
      LOCAL_NUM     CSS03.VarRoot
      LOCAL_STR     CSS03.ViewHeader
      LOCAL_STR     CSS03.TmpStr
      LOCAL_FLOAT   CSS03.TmpFloat

      IDENTIFIER_EXIST 'CSS03.Q1',[CSS03.VarExists],[CSS03.VarRoot],[CSS03.VarType]
      IF [CSS03.VarExists]=FALSE
        VAR_BROWSER CSS03.Q1
      END_IF

      QUERY [CSS03.Q1]
          SELECT Auswahl
            FROM Choicer
           WHERE ListeNummer = [CSS02.Q1!EventFlag]
             AND Sortierung = 0
        ORDER BY ListeNummer, Sortierung
      END_QUERY
      EXECUTE  [CSS03.Q1],[CSS03.QRes1]
      IF [CSS03.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln der Unterlisten-berschrift (03) konnte nicht bersetzt werden'
        CALC [CSS02.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      GET_DATA [CSS03.Q1],[CSS03.QRes1]
      IF [CSS03.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Unterlisten-berschrift (03) konnte nicht gelesen werden'
        CALC [CSS02.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      CALC [CSS03.ViewHeader] AS [CSS03.Q1!Auswahl]


      QUERY_LOAD [CSS03.Q1],[CSS03.QRes1],'CH_SUB03'
      IF [CSS03.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Eine Unterlisten-Abfrage (03) konnte nicht geladen werden'
        CALC [CSS02.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF

      IF [CSS03.SubRes]<>''
        CALC [CSS03.TmpStr] AS PART([CSS03.SubRes],2,';')
        IF [CSS03.TmpStr]<>''
          CALC [CSS03.TmpFloat]  AS VAL([CSS03.TmpStr])
          IF [CSS03.TmpFloat]>[EPSILON]
            CALC [CSS03.TmpStr] AS CON('STARTING WITH RecordID = ',[CSS03.TmpFloat|R0,0])
            QUERY_ADD_STRING [CSS03.Q1], [CSS03.TmpStr]
          ELSE
            CALC [CSS03.TmpStr] AS ''
          END_IF
        END_IF

        IF [CSS03.TmpStr]<>''
          IF [CSS04.SubRes]<>''
            FLAG_SET [CSS03.Q1!VIEW_FLAG],[BROWSER_FLAG_OK_ON_STARTING]
          END_IF
        END_IF
      END_IF

      CALC [CSS03.Q1!BROWSER_HOOK_OK] AS 'ChoicerSubSelect04'
      VIEW [CSS03.Q1],[CSS03.QRes1],[CSS03.ViewHeader]

      IF [CG.MultiSelect]=FALSE
        CALC [CSS02.Q1!VIEW_ACTION] AS 1
      ELSE
        CALC [CSS02.SubRes] AS CON([CSS01.Q1!EventFlag],';',[CSS02.Q1!RecordID|R0,0])
      END_IF
    ELSE
      CALC [CSS02.SubRes]   AS CON([CSS01.Q1!EventFlag],';',[CSS02.Q1!RecordID|R0,0])
      CALC [CG.MultiSelect] AS TRUE
    END_IF
  END_PROC


  PROCEDURE ChoicerSubSelect02
    IF [CSS01.Q1!EventFlag]>0
      LOCAL_BOOL    CSS02.VarExists
      LOCAL_BOOL    CSS02.QRes1
      LOCAL_NUM     CSS02.VarType
      LOCAL_NUM     CSS02.VarRoot
      LOCAL_STR     CSS02.ViewHeader
      LOCAL_STR     CSS02.TmpStr
      LOCAL_FLOAT   CSS02.TmpFloat

      IDENTIFIER_EXIST 'CSS02.Q1',[CSS02.VarExists],[CSS02.VarRoot],[CSS02.VarType]
      IF [CSS02.VarExists]=FALSE
        VAR_BROWSER CSS02.Q1
      END_IF

      QUERY [CSS02.Q1]
          SELECT Auswahl
            FROM Choicer
           WHERE ListeNummer = [CSS01.Q1!EventFlag]
             AND Sortierung = 0
        ORDER BY ListeNummer, Sortierung
      END_QUERY
      EXECUTE  [CSS02.Q1],[CSS02.QRes1]
      IF [CSS02.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln der Unterlisten-berschrift (02) konnte nicht bersetzt werden'
        CALC [CSS01.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      GET_DATA [CSS02.Q1],[CSS02.QRes1]
      IF [CSS02.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Unterlisten-berschrift (02) konnte nicht gelesen werden'
        CALC [CSS01.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      CALC [CSS02.ViewHeader] AS [CSS02.Q1!Auswahl]

      QUERY_LOAD [CSS02.Q1],[CSS02.QRes1],'CH_SUB02'
      IF [CSS02.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Eine Unterlisten-Abfrage (02) konnte nicht geladen werden'
        CALC [CSS01.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF

      IF [CSS02.SubRes]<>''
        CALC [CSS02.TmpStr] AS PART([CSS02.SubRes],2,';')
        IF [CSS02.TmpStr]<>''
          CALC [CSS02.TmpFloat]  AS VAL([CSS02.TmpStr])
          IF [CSS02.TmpFloat]>[EPSILON]
            CALC [CSS02.TmpStr] AS CON('STARTING WITH RecordID = ',[CSS02.TmpFloat|R0,0])
            QUERY_ADD_STRING [CSS02.Q1], [CSS02.TmpStr]
          ELSE
            CALC [CSS02.TmpStr] AS ''
          END_IF
        END_IF

        IF [CSS02.TmpStr]<>''
          IF [CSS03.SubRes]<>''
            FLAG_SET [CSS02.Q1!VIEW_FLAG],[BROWSER_FLAG_OK_ON_STARTING]
          END_IF
        END_IF
      END_IF

      CALC [CSS02.Q1!BROWSER_HOOK_OK] AS 'ChoicerSubSelect03'
      VIEW [CSS02.Q1],[CSS02.QRes1],[CSS02.ViewHeader]

      IF [CG.MultiSelect]=FALSE
        CALC [CSS01.Q1!VIEW_ACTION] AS 1
      ELSE
        CALC [CSS01.SubRes]   AS CON([CG.Q1!EventFlag],';',[CSS01.Q1!RecordID|R0,0])
      END_IF
    ELSE
      CALC [CSS01.SubRes]   AS CON([CG.Q1!EventFlag],';',[CSS01.Q1!RecordID|R0,0])
      CALC [CG.MultiSelect] AS TRUE
    END_IF
  END_PROC


  PROCEDURE ChoicerSubSelect01
    IF [CG.Q1!EventFlag]>0
      LOCAL_BOOL    CSS01.VarExists
      LOCAL_BOOL    CSS01.QRes1
      LOCAL_NUM     CSS01.VarType
      LOCAL_NUM     CSS01.VarRoot
      LOCAL_STR     CSS01.ViewHeader
      LOCAL_STR     CSS01.TmpStr
      LOCAL_FLOAT   CSS01.TmpFloat

      IDENTIFIER_EXIST 'CSS01.Q1',[CSS01.VarExists],[CSS01.VarRoot],[CSS01.VarType]
      IF [CSS01.VarExists]=FALSE
        VAR_BROWSER CSS01.Q1
      END_IF

      QUERY [CSS01.Q1]
          SELECT Auswahl
            FROM Choicer
           WHERE ListeNummer = [CG.Q1!EventFlag]
             AND Sortierung = 0
        ORDER BY ListeNummer, Sortierung
      END_QUERY

      EXECUTE  [CSS01.Q1],[CSS01.QRes1]
      IF [CSS01.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Abfrage zum Ermitteln der Unterlisten-berschrift (01) konnte nicht bersetzt werden'
        CALC [CG.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      GET_DATA [CSS01.Q1],[CSS01.QRes1]
      IF [CSS01.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Die Unterlisten-berschrift (01) konnte nicht gelesen werden'
        CALC [CG.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF
      CALC [CSS01.ViewHeader] AS [CSS01.Q1!Auswahl]

      QUERY_LOAD [CSS01.Q1],[CSS01.QRes1],'CH_SUB01'
      IF [CSS01.QRes1]=FALSE
        MESSAGE 'Achtung Abbruch','Eine Unterlisten-Abfrage (01) konnte nicht geladen werden'
        CALC [CG.Q1!VIEW_ACTION] AS 1
        EXIT_PROC
      END_IF

      IF [CSS01.SubRes]<>''
        CALC [CSS01.TmpStr] AS PART([CSS01.SubRes],2,';')
        IF [CSS01.TmpStr]<>''
          CALC [CSS01.TmpFloat]  AS VAL([CSS01.TmpStr])
          IF [CSS01.TmpFloat]>[EPSILON]
            CALC [CSS01.TmpStr] AS CON('STARTING WITH RecordID = ',[CSS01.TmpFloat|R0,0])
            QUERY_ADD_STRING [CSS01.Q1], [CSS01.TmpStr]
          ELSE
            CALC [CSS01.TmpStr] AS ''
          END_IF
        END_IF

        IF [CSS01.TmpStr]<>''
          IF [CSS02.SubRes]<>''
            FLAG_SET [CSS01.Q1!VIEW_FLAG],[BROWSER_FLAG_OK_ON_STARTING]
          END_IF
        END_IF
      END_IF

      CALC [CSS01.Q1!BROWSER_HOOK_OK] AS 'ChoicerSubSelect02'
      VIEW [CSS01.Q1],[CSS01.QRes1],[CSS01.ViewHeader]

      IF [CG.MultiSelect]=FALSE
        CALC [CG.Q1!VIEW_ACTION] AS 1
      ELSE
       ; Raus hier !
      END_IF
    ELSE
      CALC [CG.MultiSelect] AS FALSE
    END_IF
  END_PROC


  PROCEDURE ChoicerGet VB CG.ViewIt, VS CG.MaskName, VS CG.VarName, VS CG.VarNameView, VN CG.ChoicerList, VS CG.ChoicerField, VS CG.HeaderField, VN CG.HeaderWidth, VS CG.HeaderName, VS CG.ViewHeader, ~VB CG.Result
    LOCAL_STR     CG.QueryStr1
    LOCAL_STR     CG.QueryStr2
    LOCAL_STR     CG.QueryStr3
    LOCAL_STR     CG.QueryStr4
    LOCAL_STR     CG.QueryStr5
    LOCAL_STR     CG.QueryStr6
    LOCAL_STR     CG.VarBez
    LOCAL_STR     CG.VarBezView
    LOCAL_STR     CG.Brackets
    LOCAL_STR     CG.VarFormat
    LOCAL_STR     CG.QueryID
    LOCAL_STR     CG.VarValue
    LOCAL_BOOL    CG.VarExists
    LOCAL_NUM     CG.VarTypeView
    LOCAL_NUM     CG.VarType
    LOCAL_NUM     CG.VarRoot
    LOCAL_NUM     CG.YNRes
    LOCAL_BOOL    CG.QRes1
    LOCAL_STR     CG.TmpStr1
    LOCAL_STR     CG.TmpStr2
    LOCAL_STR     CG.TmpStr3
    LOCAL_NUM     CG.MaxDepth, 10
    LOCAL_FLOAT   CG.TmpFloat

    IDENTIFIER_EXIST 'CG.Q1',[CG.VarExists],[CG.VarRoot],[CG.VarType]
    IF [CG.VarExists]=FALSE
      VAR_BROWSER CG.Q1
      VAR_BOOL    CG.MultiSelect
      VAR_STR     CG.MultiResult

      VAR_STR     CSS01.SubRes
      VAR_STR     CSS02.SubRes
      VAR_STR     CSS03.SubRes
      VAR_STR     CSS04.SubRes
      VAR_STR     CSS05.SubRes
      VAR_STR     CSS06.SubRes
      VAR_STR     CSS07.SubRes
      VAR_STR     CSS08.SubRes
      VAR_STR     CSS09.SubRes
      VAR_STR     CSS10.SubRes
    END_IF

    CALC [CG.YNRes] AS 1
    WHILE [CG.YNRes]<=[CG.MaxDepth]
      CALC [CG.TmpStr1]   AS [CG.YNRes]
      CALC [CG.TmpStr1]   AS EXT([CG.TmpStr1],2,48,2,1)
      CALC [CG.TmpStr1]   AS CON('CSS',[CG.TmpStr1],'.SubRes')
      CALC [[CG.TmpStr1]] AS ''
      INC  [CG.YNRes]
    END_WHILE

    CALC [CG.QueryStr5]   AS PART([CG.HeaderName],2,'|')
    CALC [CG.HeaderName]  AS PART([CG.HeaderName],1,'|')
    IF [CG.QueryStr5]<>''
      CALC [CG.QueryStr5] AS CON([CG.QueryStr5],', ')
    END_IF
    CALC [CG.QueryID]     AS [CG.HeaderName]

    CALC [CG.MultiResult] AS ''
    CALC [CG.MultiSelect] AS FALSE
    CALC [CG.Brackets]    AS ''

    CALC [CG.QueryStr1]   AS ''
    CALC [CG.QueryStr2]   AS ''
    CALC [CG.QueryStr3]   AS ''
    CALC [CG.QueryStr4]   AS ''

    CALC [CG.VarFormat]   AS ''

    CALC [CG.TmpStr2] AS UPCASE([CG.ChoicerField])
    CALC [CG.TmpStr3] AS UPCASE([CG.HeaderField])
    IF [CG.TmpStr2]<>'RECORDID'
      IF [CG.TmpStr3]<>'RECORDID'
        CALC [CG.QueryStr3] AS 'RecordID, '
      END_IF
    END_IF

    IF [CG.TmpStr2]<>[CG.TmpStr3]
      CALC [CG.QueryStr4] AS CON([CG.ChoicerField],', ')
    END_IF

    CALC [CG.VarBez] AS [CG.VarName]
    IF [CG.MaskName]<>''
      CALC [CG.VarBez]  AS CON([CG.MaskName],'!',[CG.VarName])
      CALC [CG.QueryID] AS CON([CG.MaskName],'_',[CG.VarName],'_',[CG.QueryID])
    ELSE
      CALC [CG.QueryID] AS CON([CG.VarName],'_',[CG.QueryID])
    END_IF

    IDENTIFIER_EXIST [CG.VarBez],[CG.VarExists],[CG.VarRoot],[CG.VarType]
    IF [CG.VarExists]=FALSE
      MESSAGE 'Achtung Choicer-Fehler','Aufruf mit einer unbekannten Variable'
      CALC [CG.Result] AS FALSE
      EXIT_PROC
    END_IF


    CALC [CG.VarBezView] AS [CG.VarNameView]
    IF [CG.VarBezView]<>''
      IF [CG.MaskName]<>''
        CALC [CG.VarBezView] AS CON([CG.MaskName],'!',[CG.VarNameView])
      END_IF

      IDENTIFIER_EXIST [CG.VarBezView],[CG.VarExists],[CG.VarRoot],[CG.VarTypeView]
      IF [CG.VarExists]=FALSE
        MESSAGE 'Achtung Choicer-Fehler','Aufruf mit einer unbekannten Anzeige-Variable'
        CALC [CG.Result] AS FALSE
        EXIT_PROC
      END_IF
    END_IF

    CALC [CG.ChoicerField] AS UPCASE([CG.ChoicerField])

    CALC [CG.TmpStr2] AS UPCASE([CG.ChoicerField])
    IF [CG.TmpStr2]='RECORDID'
      CALC [CG.VarFormat] AS '|R0,0'
    END_IF
    CALC [CG.QueryStr1] AS CON('AND ',[CG.ChoicerField],' = ')

    IF [CG.QueryStr5]<>''
      CALC [CG.QueryStr2] AS CON('STARTING WITH ',[CG.ChoicerField],' >= ')
    ELSE
      CALC [CG.QueryStr2] AS CON('STARTING WITH ',[CG.ChoicerField],' = ')
    END_IF

    CALC [CG.VarValue] AS [[CG.VarBez][CG.VarFormat]]


    IF [CG.ChoicerField]='AUSWAHL'
      ; string (41)
      CALC [CG.Brackets] AS '"'
    ELSE_IF [CG.ChoicerField]='WERT1'
      ; integer
    ELSE_IF [CG.ChoicerField]='WERT2'
      ; numeric / float
      CALC [CG.VarValue] AS [[CG.VarBez]|R0,0]
    ELSE_IF [CG.ChoicerField]='WERT3'
      ; string (1)
      CALC [CG.Brackets]  AS '"'
    ELSE_IF [CG.ChoicerField]='WERT4'
      ; string (64)
      CALC [CG.Brackets]  AS '"'
    ELSE_IF [CG.ChoicerField]='WERT5'
      ; boolean
      CALC [CG.Brackets]  AS [SQL_BOOLEAN_QUOTATION]
      CALC [CG.VarValue] AS [SQL_BOOLEAN_FALSE]
      IF [[CG.VarBez]]
        CALC [CG.VarValue] AS [SQL_BOOLEAN_TRUE]
      END_IF
    ELSE_IF [CG.ChoicerField]='KURZBEZ'
      ; string (21)
      CALC [CG.Brackets]  AS '"'
    ELSE_IF [CG.ChoicerField]='LISTENUMMER'
      ; integer
    ELSE_IF [CG.ChoicerField]='SORTIERUNG'
      ; integer
    END_IF

    CALC [CG.QueryStr1] AS CON([CG.QueryStr1],[CG.Brackets],[CG.VarValue],[CG.Brackets],' ')
    CALC [CG.QueryStr2] AS CON([CG.QueryStr2],[CG.Brackets],[CG.VarValue],[CG.Brackets],' ')

    IF [CG.ViewIt]
      CALC [CG.QueryStr1] AS ''
      CALC [CG.YNRes]     AS POS(';',[CG.VarValue])
      IF [CG.YNRes]>0
        CALC [CG.QueryStr2]   AS ''
        CALC [CG.MultiResult] AS [CG.VarValue]

        CALC [CG.QueryStr2]   AS PART([CG.MultiResult], 1,',')
        CALC [CG.QueryStr2]   AS PART([CG.QueryStr2],   2,';')
        IF [CG.QueryStr2]<>''
          CALC [CG.TmpFloat]  AS VAL([CG.QueryStr2])
          IF [CG.TmpFloat]>[EPSILON]
            CALC [CG.QueryStr2] AS CON('STARTING WITH RecordID = ',[CG.TmpFloat|R0,0])
          ELSE
            CALC [CG.QueryStr2] AS ''
          END_IF
        END_IF

        CALC [CG.YNRes] AS 1
        WHILE [CG.YNRes]<=[CG.MaxDepth]
          CALC [CG.TmpStr1]   AS [CG.YNRes]
          CALC [CG.TmpStr1]   AS EXT([CG.TmpStr1],2,48,2,1)
          CALC [CG.TmpStr1]   AS CON('CSS',[CG.TmpStr1],'.SubRes')
          CALC [CG.VarType]   AS [CG.YNRes] + 1
          CALC [CG.TmpStr2]   AS PART([CG.MultiResult], [CG.VarType],',')
          CALC [[CG.TmpStr1]] AS [CG.TmpStr2]
          INC  [CG.YNRes]
        END_WHILE
      END_IF
    ELSE
      CALC [CG.QueryStr2] AS ''
    END_IF

    IF [CG.QueryStr5]<>''
      CALC [CG.QueryStr6] AS '[W15]'
    ELSE
      CALC [CG.QueryStr6] AS '[H]'
    END_IF


    QUERY [CG.Q1]
        SELECT [N "[CG.HeaderName]" W[CG.HeaderWidth]][CG.HeaderField], [CG.QueryStr6][CG.QueryStr4][CG.QueryStr3] RecFlag, EventFlag
          FROM Choicer
         WHERE ListeNummer = [CG.ChoicerList]
           AND Sortierung > 0
         [CG.QueryStr1]
      ORDER BY ListeNummer, [CG.QueryStr5] Sortierung
      [CG.QueryStr2]
    END_QUERY

    CALC [CG.Q1!QUERY_ID] AS [CG.QueryID]

    CALC [CG.TmpStr2] AS ''

    IF [CG.ViewIt]
      FLAG_SET [CG.Q1!VIEW_FLAG],[BROWSER_FLAG_ICON_INSERT]

      IF [CG.MultiResult]<>''
        IF [CSS01.SubRes]<>''
          FLAG_SET [CG.Q1!VIEW_FLAG],[BROWSER_FLAG_OK_ON_STARTING]
        END_IF
      END_IF

      CALC [CG.Q1!BROWSER_HOOK_INSERT] AS 'ChoicerInsert'
      CALC [CG.Q1!BROWSER_HOOK_OK]     AS 'ChoicerSubSelect01'

      VIEW [CG.Q1],[CG.QRes1],[CG.ViewHeader]

      IF [CG.MultiSelect]
        CALC [CG.TmpStr2] AS CON([CG.ChoicerList],';',[CG.Q1!RecordID|R0,0])

        CALC [CG.YNRes] AS 1
        WHILE [CG.YNRes]<=[CG.MaxDepth]
          CALC [CG.TmpStr1] AS [CG.YNRes]
          CALC [CG.TmpStr1] AS EXT([CG.TmpStr1],2,48,2,1)
          CALC [CG.TmpStr1] AS CON('CSS',[CG.TmpStr1],'.SubRes')
          CALC [CG.TmpStr3] AS [[CG.TmpStr1]]
          IF [CG.TmpStr3]<>''
            CALC [CG.TmpStr2] AS CON([CG.TmpStr2],',',[CG.TmpStr3])
          ELSE
            CALC [CG.YNRes] AS [CG.MaxDepth] + 1
          END_IF

          INC [CG.YNRes]
        END_WHILE

        CALC [CG.MultiResult] AS [CG.TmpStr2]
      ELSE
        IF [CG.QRes1]
          CALC [CG.TmpStr2] AS [CG.Q1![CG.ChoicerField]]
        END_IF
      END_IF
    ELSE
      EXECUTE [CG.Q1],[CG.QRes1]
      IF [CG.QRes1]=FALSE
        CALC [CG.QueryStr1] AS CON('Die ',[CG.ViewHeader],'-Abfrage konnte nicht bersetzt werden')
        MESSAGE 'Achtung',[CG.QueryStr1],[MESSAGE_ERROR]
      ELSE
        GET_DATA [CG.Q1],[CG.QRes1]
        IF [CG.QRes1]
          CALC [CG.TmpStr2] AS [CG.Q1![CG.ChoicerField]]
        END_IF
      END_IF
    END_IF

    IF [CG.VarType]=[SCRIPT_NUM]
    ELSE_IF [CG.VarType]=[SCRIPT_FLOAT]
    ELSE_IF [CG.VarType]=[SCRIPT_STRING]
    ELSE_IF [CG.VarType]=[SCRIPT_BOOLEAN]
    END_IF

    CALC [CG.Result] AS [CG.QRes1]
    IF [CG.QRes1]=FALSE
      IF [CG.ViewIt]
        CALC [CG.YNRes] AS [ID_NO]
        GET_YES_NO 'Achtung','Soll die bisherige Zuordnung aufgehoben werden ?',[CG.YNRes]
        IF [CG.YNRes]=[ID_YES]
          IF [CG.VarType]=[SCRIPT_NUM]
            CALC [[CG.VarBez]] AS 0
          ELSE_IF [CG.VarType]=[SCRIPT_FLOAT]
            CALC [[CG.VarBez]] AS 0.0
          ELSE_IF [CG.VarType]=[SCRIPT_STRING]
            CALC [[CG.VarBez]] AS ''
          ELSE_IF [CG.VarType]=[SCRIPT_BOOLEAN]
            CALC [[CG.VarBez]] AS FALSE
          END_IF

          IF [CG.VarBezView]<>''
            IF [CG.VarTypeView]=[SCRIPT_NUM]
              CALC [[CG.VarBezView]] AS 0
            ELSE_IF [CG.VarTypeView]=[SCRIPT_FLOAT]
              CALC [[CG.VarBezView]] AS 0.0
            ELSE_IF [CG.VarTypeView]=[SCRIPT_STRING]
              CALC [[CG.VarBezView]] AS ''
            ELSE_IF [CG.VarTypeView]=[SCRIPT_BOOLEAN]
              CALC [[CG.VarBezView]] AS FALSE
            END_IF
          END_IF
        END_IF
      ELSE
        IF [CG.VarType]=[SCRIPT_NUM]
          CALC [[CG.VarBez]] AS 0
        ELSE_IF [CG.VarType]=[SCRIPT_FLOAT]
          CALC [[CG.VarBez]] AS 0.0
        ELSE_IF [CG.VarType]=[SCRIPT_STRING]
          CALC [[CG.VarBez]] AS ''
        ELSE_IF [CG.VarType]=[SCRIPT_BOOLEAN]
          CALC [[CG.VarBez]] AS FALSE
        END_IF

        IF [CG.VarBezView]<>''
          IF [CG.VarTypeView]=[SCRIPT_NUM]
            CALC [[CG.VarBezView]] AS 0
          ELSE_IF [CG.VarTypeView]=[SCRIPT_FLOAT]
            CALC [[CG.VarBezView]] AS 0.0
          ELSE_IF [CG.VarTypeView]=[SCRIPT_STRING]
            CALC [[CG.VarBezView]] AS ''
          ELSE_IF [CG.VarTypeView]=[SCRIPT_BOOLEAN]
            CALC [[CG.VarBezView]] AS FALSE
          END_IF
        END_IF
      END_IF

      IF [CG.MaskName]<>''
        MASK_UPDATE [[CG.MaskName]]
      END_IF

      EXIT_PROC
    END_IF

    IF [CG.VarBezView]<>''
      CALC [[CG.VarBezView]] AS [CG.Q1![CG.HeaderField]]
    END_IF

    CALC [[CG.VarBez]] AS [CG.TmpStr2]

    IF [CG.MaskName]<>''
      MASK_UPDATE [[CG.MaskName]]
    END_IF
  END_PROC
