;Suche nach ;NewFibuKng

  PROCEDURE LoadRelationFields VF LocRelID, VS LocTableName, VS LocCompFld, ~VS LocResFld, VS LocInfo
    ; Ldt aus der Tabelle LocTableName den Datensatz LocRelID und gibt den Inhalt
    ; des Feldes LocCompFld an LocResFld zurck. Mit LocInfo kann man eine locale Info ausgeben,
    ; falls der Datensatz nicht geladen werden konnte. In LocCompFld kann man mehrere Felder mit "|"
    ; getrennt angeben. Die Inhalte werden dann in LocResFld durch "|" getrennt zurckgegeben.

    LOCAL_NUM   LocNum
    LOCAL_STR   LocTmpStr1
    LOCAL_STR   LocTmpStr2
    LOCAL_STR   LocQueryStr
    LOCAL_BOOL  LocQRes
    LOCAL_QUERY LocQ

    CALC [LocResFld] AS ''
    IF [LocRelID]<[EPSILON]
      EXIT_PROC
    END_IF

    CALC [LocTmpStr1]  AS [LocCompFld]
    CALC [LocQueryStr] AS CON([LocCompFld],',')

    CALC [LocNum] AS POS('|',[LocCompFld])
    IF [LocNum]>0
      CALC [LocQueryStr] AS ''
    END_IF

    WHILE [LocNum]>0
      CALC [LocNum] AS POS('|',[LocTmpStr1])

      IF [LocNum]>0
        DEC [LocNum]
        CALC [LocTmpStr2] AS COPY([LocTmpStr1],1,[LocNum])
        CALC [LocTmpStr2] AS TRIM([LocTmpStr2])

        CALC [LocNum]     AS [LocNum]+2
        CALC [LocTmpStr1] AS COPY([LocTmpStr1],[LocNum],250)
        CALC [LocTmpStr1] AS TRIM([LocTmpStr1])
      ELSE
        CALC [LocTmpStr2] AS TRIM([LocTmpStr1])
      END_IF

      IF [LocTmpStr2]<>''
        CALC [LocQueryStr] AS CON([LocQueryStr],[LocTmpStr2],',')
      END_IF
    END_WHILE

    CALC [LocQueryStr] AS CON([LocQueryStr],'RecordID ')

    QUERY [LocQ]
      SELECT [LocQueryStr]
        FROM [LocTableName]
       WHERE RecordID = [LocRelID|R0,0]
    END_QUERY

    EXECUTE [LocQ],[LocQRes]
    IF [LocQRes]=FALSE
      MESSAGE 'Abbruch','Das Query zum Laden der Relation konnte nicht geladen werden.',[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [LocQ],[LocQRes]
    IF [LocQRes]=FALSE
      IF [LocInfo]<>''
        MESSAGE 'Abbruch',[LocInfo],[MESSAGE_ERROR]
      END_IF
      EXIT_PROC
    END_IF

    CALC [LocNum] AS POS('|',[LocCompFld])
    IF [LocNum]<=0
      CALC [LocResFld] AS [LocQ![LocCompFld]]
      EXIT_PROC
    END_IF

    CALC [LocResFld]  AS ''
    CALC [LocTmpStr1] AS [LocCompFld]

    WHILE [LocNum]>0
      CALC [LocNum] AS POS('|',[LocTmpStr1])

      IF [LocNum]>0
        DEC [LocNum]
        CALC [LocTmpStr2] AS COPY([LocTmpStr1],1,[LocNum])

        CALC [LocNum] AS [LocNum]+2

        CALC [LocTmpStr1] AS COPY([LocTmpStr1],[LocNum],250)
        CALC [LocTmpStr1] AS TRIM([LocTmpStr1])
      ELSE
        CALC [LocTmpStr2] AS TRIM([LocTmpStr1])
      END_IF

      IF [LocTmpStr2]<>''
        CALC [LocTmpStr2] AS [LocQ![LocTmpStr2]]
        CALC [LocResFld]  AS CON([LocResFld],[LocTmpStr2],'|')
      END_IF
    END_WHILE
  END_PROC


  PROCEDURE LoadFormularName VF LocRelID, VS LocTableName, VS LocRelField, VS LocFeldName, VB LocGetLLFile, ~VS LocFormularName
    ; Ldt aus der Tabelle ADRESSEN zum Datensatz LocRelID bzw. LocTableName und dann
    ; Adressen den Formularnamen LocFeldName und gibt LocFormularName zurck.
    ; Falls LocGetLLFile TRUE wird nach einem LST-File gesucht, andernfalls wird
    ; eine .csh Datei gesucht. Falls ein LST-Name angefordert wird und nur ein CSH-Name
    ; gefunden wird, wird ein Leerstring zurckgegeben und umgekehrt.

    CALC [LocFormularName] AS ''

    IF [LocRelID]<[EPSILON]
      EXIT_PROC
    END_IF

    IF [LocFeldName]=''
      EXIT_PROC
    END_IF

    LOCAL_BOOL  LocQRes
    LOCAL_FLOAT LocID
    LOCAL_STR   LocStr
    LOCAL_QUERY LocQ

    CALC [LocID] AS [LocRelID]

    IF [LocTableName]<>''
      QUERY [LocQ]
        SELECT [LocRelField], RecordID
          FROM [LocTableName]
         WHERE RecordID = [LocRelID|R0,0]
      END_QUERY

      EXECUTE [LocQ],[LocQRes]
      IF [LocQRes]=FALSE
        EXIT_PROC
      END_IF

      GET_DATA [LocQ],[LocQRes]
      IF [LocQRes]=FALSE
        EXIT_PROC
      END_IF

      CALC [LocID] AS [LocQ![LocRelField]]
    END_IF

    QUERY [LocQ]
      SELECT [LocFeldName], RecordID
        FROM ADRESSEN
       WHERE RecordID = [LocID|R0,0]
    END_QUERY

    EXECUTE [LocQ],[LocQRes]
    IF [LocQRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [LocQ],[LocQRes]
    IF [LocQRes]=FALSE
      EXIT_PROC
    END_IF

    CALC [LocFormularName] AS [LocQ![LocFeldName]]

    FILE_EXT [LocStr],[LocFormularName]
    CALC [LocStr] AS UPCASE([LocStr])

    IF [LocGetLLFile]
      ; lst-file wird gesucht
      IF [LocStr]<>'.LST'
        CALC [LocFormularName] AS ''
      END_IF
    ELSE
      ; csh-file wird gesucht
      IF [LocStr]<>'.CSH'
        CALC [LocFormularName] AS ''
      END_IF
    END_IF
  END_PROC



  PROCEDURE CalculateOneVal VS RCV.LocQueryStr, VS RCV.LocQFld, ~VF RCV.LocResult, ~VB RCV.LocQRes
    CALC [RCV.LocQRes]   AS FALSE
    CALC [RCV.LocResult] AS 0.0

    LOCAL_QUERY RCV.LocQ

    QUERY [RCV.LocQ]
      [RCV.LocQueryStr]
    END_QUERY

    EXECUTE [RCV.LocQ],[RCV.LocQRes]
    IF [RCV.LocQRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [RCV.LocQ],[RCV.LocQRes]
    IF [RCV.LocQRes]=FALSE
      CALC [RCV.LocQRes] AS TRUE
      EXIT_PROC
    END_IF

    CALC [RCV.LocResult] AS [RCV.LocQ![RCV.LocQFld]]
  END_PROC



  PROCEDURE ExecuteAQuery VS REQ.LocQueryStr, ~VB REQ.LocQRes
    CALC [REQ.LocQRes] AS FALSE

    LOCAL_QUERY REQ.LocQ

    QUERY [REQ.LocQ]
      [REQ.LocQueryStr]
    END_QUERY

    EXECUTE [REQ.LocQ],[REQ.LocQRes]
  END_PROC



  PROCEDURE RoundMoney ~VF RndVal
    LOCAL_STR RoundStr
    CALC [RoundStr] AS [RndVal|R0,2]
    CALC [RndVal] AS VAL([RoundStr])
  END_PROC



  PROCEDURE EuroDM VF LWFaktor, VF InBetrag, ~VF OutBetrag
    LOCAL_STR RoundStr

    IF [LWFaktor]<0
      CALC [OutBetrag] AS [InBetrag]/[LWFaktor]*(-1)
    ELSE
      CALC [OutBetrag] AS [InBetrag]*[LWFaktor]
    END_IF

    CALC [RoundStr] AS [OutBetrag|R0,5]
    CALC [OutBetrag] AS VAL([RoundStr])
  END_PROC




  PROCEDURE GetWFaktor2 VF LocWaehrungID, ~VF LocFFaktor, ~VF LocSFaktor, ~VS LocWStr, ~VB LocIsSystem, ~VB LocIsEuro, ~VB LocQRes
    LOCAL_QUERY LocQ

    QUERY [LocQ]
      SELECT RecordID, FFaktor, SFaktor, IsEuro, Systemwaehrung, Waehrung
        FROM Waehrung
       WHERE RecordID = [LocWaehrungID|R0,0]
    END_QUERY

    EXECUTE [LocQ], [LocQRes]
    IF [LocQRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [LocQ], [LocQRes]
    IF [LocQRes]=FALSE
      EXIT_PROC
    END_IF

    CALC [LocWStr]     AS [LocQ!Waehrung]
    CALC [LocFFaktor]  AS [LocQ!FFaktor]
    CALC [LocSFaktor]  AS [LocQ!SFaktor]
    CALC [LocIsEuro]   AS [LocQ!IsEuro]
    CALC [LocIsSystem] AS [LocQ!Systemwaehrung]
  END_PROC




  PROCEDURE GetWFaktor VF LWaehrungID, ~VF LWFaktor, ~VS LocWStr, ~VF LocSFaktor, ~VB LocIsEuro
    LOCAL_BOOL  LPQRes
    LOCAL_FLOAT LocTmpFloat
    LOCAL_QUERY LPQ

    CALC [LocWStr]    AS [CURRENCY_STR]
    CALC [LWFaktor]   AS [IP_CURRENCY_FFAKTOR]
    CALC [LocIsEuro]  AS [IP_CURRENCY_IS_EURO]
    CALC [LocSFaktor] AS [IP_CURRENCY_SFAKTOR]

    CALC [LocTmpFloat] AS ABS([LWaehrungID]-[CURRENCY_ID])
    IF [LocTmpFloat]<[EPSILON]
      EXIT_PROC
    END_IF

    QUERY [LPQ]
      SELECT RecordID, FFaktor, SFaktor, IsEuro, Waehrung
        FROM WAEHRUNG
       WHERE RecordID = [LWaehrungID|R0,0]
    END_QUERY

    EXECUTE [LPQ],[LPQRes]
    IF [LPQRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [LPQ],[LPQRes]
    IF [LPQRes]=FALSE
      EXIT_PROC
    END_IF

    CALC [LocWStr]    AS [LPQ!Waehrung]
    CALC [LWFaktor]   AS [LPQ!FFaktor]
    CALC [LocIsEuro]  AS [LPQ!IsEuro]
    CALC [LocSFaktor] AS [LPQ!SFaktor]
  END_PROC




  ; Version 4.05.05 +
  PROCEDURE ReadMaskSwitch VS RMS.MaskName, ~VN RMS.OpenMode, ~VB RMS.SaveLastMode
    LOCAL_BOOL RMS.QRes
    LOCAL_NUM  RMS.TmpNum
    LOCAL_STR  RMS.DateiName
    CALC [RMS.DateiName] AS CON([SPECIAL_PATH],'IDEALMSK.CFG')

    ; lies die Einstellungen aus der Maske-CFG
    INI_READ	[RMS.QRes], [RMS.OpenMode], [SCRIPT_NUM], [RMS.DateiName], 'LP_OPEN_MODE', [RMS.MaskName]
    IF [RMS.OpenMode]=0
      ; keine gefunden
      CALC [RMS.OpenMode] AS [IP_MASK_OPEN_MODE]
    END_IF

    INI_READ	[RMS.QRes], [RMS.TmpNum], [SCRIPT_NUM], [RMS.DateiName], 'LP_LAST_MODE', [RMS.MaskName]
    IF [RMS.TmpNum]=1
      CALC [RMS.SaveLastMode] AS TRUE
    ELSE_IF [RMS.TmpNum]=2
      CALC [RMS.SaveLastMode] AS FALSE
    ELSE
      ; keine gefunden
      CALC [RMS.SaveLastMode] AS [IP_MASK_SAVE_LAST_MODE]
    END_IF
  END_PROC
  ; Version 4.05.05 -


  PROCEDURE FindSteuerSatz VF LKontoID, VD LStDatum, ~VN LStNr, ~VF LStSatz, ~VB LStOK
    ; Ein Artikel ist mit einem Konto verbunden.
    ; Dieses Konto verweist auf einen SteuerSchluessel, Feld StSchl.
    ; Aus diesem Steuerschluessel wird der gltige Prozentsatz (Datum) abgelesen.

    CALC [LStOK]   AS FALSE
    CALC [LStNr]   AS 1
    CALC [LStSatz] AS [IP_FIBU_DEFAULT_STEUERSATZ]

    IF [LKontoID]<[EPSILON]
      IF [IP_FIBU_DEFAULT_STEUERSATZ]>[EPSILON]
        CALC [LStOK] AS TRUE
        EXIT_PROC
      END_IF
    END_IF

    LOCAL_QUERY LStQ

    ; steht im aktuellen Konto unter FreeNum1 ein Wert > 0, gibt es ein Vorgngerkonto

    ;     AND AbDatum <= [SQL_DATE_QUOTES_4_SELECT][LStDatum|R8,[SQL_DATE_PICTURE_4_SELECT]][SQL_DATE_QUOTES_4_SELECT]
    ;   ORDER BY AbDatum

    QUERY [LStQ]
      SELECT Kontonummer, Prozent, StSchl, FreeDate1, FreeNum1, RecordID
        FROM KONTEN
       WHERE RecordID = [LKontoID|R0,0]
    END_QUERY

    EXECUTE [LStQ],[LStOK]
    IF [LStOK]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [LStQ],[LStOK]
    IF [LStOK]=FALSE
      EXIT_PROC
    END_IF

    CALC [LStOK]   AS TRUE
    CALC [LStNr]   AS [LStQ!StSchl]
    CALC [LStSatz] AS [LStQ!Prozent]
  END_PROC



  PROCEDURE SonderStSatz VF LSSArtikelID, VN LSSKng, ~VF LSKontoID, ~VF LSSSatz, ~VN LSStSchl, ~VB LSSOK
    ; liefert nach Uebergabe der ArtikelID und der FibuKng
    ; den Steuersatz fr einen Sonderartikel, z.B. Fracht, Verpackung
    CALC [LSSOK]   AS FALSE
    CALC [LSSSatz] AS [IP_FIBU_DEFAULT_STEUERSATZ]

;NewFibuKng+
    LOCAL_QUERY LSSQ

    QUERY [LSSQ]
      SELECT A.Konto0,  A.Konto1,  A.Konto2,  A.Konto3,  A.Konto4,
             A.Konto10, A.Konto11, A.Konto12, A.Konto13, A.Konto14,
             K.RecordID, K.Prozent, K.StSchl
        FROM ARTIKEL A, KONTEN K
       WHERE A.RecordID = [LSSArtikelID|R0,0]
         AND A.Konto[LSSKng] = K.RecordID
    END_QUERY
;NewFibuKng-

    EXECUTE [LSSQ],[LSSOK]
    IF [LSSOK]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [LSSQ],[LSSOK]
    IF [LSSOK]=FALSE
      EXIT_PROC
    END_IF

    CALC [LSSOK]     AS TRUE
    CALC [LSSSatz]   AS [LSSQ!K.Prozent]
    CALC [LSStSchl]  AS [LSSQ!K.StSchl]
    CALC [LSKontoID] AS [LSSQ!K.RecordID]
  END_PROC



  ; Neue Routine von SS, die unabhngig von der Systemwhrung und EURO-Whrung arbeitet
  ; Die alte Routine konnte keine Umrechnung von Fremdwhrung in Fremdwhrung
  PROCEDURE ConvertPrice2 VF CP.InID, VF CP.InPreis, VF CP.InFFaktor, VF CP.InSFaktor, VF CP.OutID, VN CP.OutDigits, ~VF CP.OutPreis, ~VB CP.OutIsSystem, ~VB CP.QRes
    LOCAL_BOOL  CP.InIsEuro
    LOCAL_BOOL  CP.SelectData, FALSE

    LOCAL_FLOAT CP.TmpFloat

    LOCAL_QUERY CP.OutQ
    LOCAL_QUERY CP.InQ

    CALC [CP.QRes] AS TRUE

    IF [CP.InFFaktor]<[EPSILON]
      CALC [CP.SelectData] AS TRUE

    ELSE_IF [CP.InSFaktor]<[EPSILON]
      CALC [CP.SelectData] AS TRUE
    END_IF

    IF [CP.SelectData]
      QUERY [CP.InQ]
        SELECT RecordID, FFaktor, SFaktor, IsEuro
          FROM Waehrung
         WHERE RecordID = [CP.InID|R0,0]
        ORDER BY RecordID
      END_QUERY

      EXECUTE [CP.InQ], [CP.QRes]
      IF [CP.QRes]=FALSE
        EXIT_PROC
      END_IF

      GET_DATA [CP.InQ], [CP.QRes]
      IF [CP.QRes]=FALSE
        EXIT_PROC
      END_IF

      CALC [CP.InFFaktor]  AS [CP.InQ!FFaktor]
      CALC [CP.InSFaktor]  AS [CP.InQ!SFaktor]
      CALC [CP.InIsEuro]   AS [CP.InQ!IsEuro]
      CALC [CP.SelectData] AS FALSE
    END_IF


    QUERY [CP.OutQ]
      SELECT RecordID, FFaktor, SFaktor, Systemwaehrung, IsEuro, Aktiv, WDigits
        FROM Waehrung
       WHERE RecordID = [CP.OutID|R0,0]
      ORDER BY RecordID
    END_QUERY

    EXECUTE [CP.OutQ], [CP.QRes]
    IF [CP.QRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [CP.OutQ], [CP.QRes]
    IF [CP.QRes]=FALSE
      EXIT_PROC
    END_IF

    IF [CP.OutDigits]=0
      CALC [CP.OutDigits] AS [CP.OutQ!WDigits]
    END_IF

    CALC [CP.OutIsSystem] AS [CP.OutQ!Systemwaehrung]
    CALC [CP.TmpFloat]    AS ABS([CP.InID]-[CP.OutID])

    IF [CP.TmpFloat]<[EPSILON]
      ; Eingangs- und Ausgangswhrung sind gleich
      CALC [CP.OutPreis] AS [CP.InPreis|R0,[CP.OutDigits]]
      EXIT_PROC
    END_IF

    CALC [CP.OutPreis] AS [CP.InPreis]/[CP.InFFaktor]*[CP.InSFaktor]/[CP.OutQ!SFaktor]*[CP.OutQ!FFaktor]
    CALC [CP.OutPreis] AS [CP.OutPreis|R0,[CP.OutDigits]]
  END_PROC


  ; Version 4.10.03 +
  PROCEDURE ConvertPrice VF CP.InID, VF CP.InPreis, VF CP.OutID, VF CP.OutFaktor, VF CP.InFaktor, VB CP.IsEuro, ~VF CP.OutPreis, ~VB CP.QRes
    LOCAL_BOOL  CP.OutIsSystem
    LOCAL_FLOAT CP.LocFloat

    CALC [CP.LocFloat] AS ABS([CP.InID]-[CP.OutID])
    IF [CP.LocFloat]<[EPSILON]
      CALC [CP.QRes]     AS TRUE
      CALC [CP.OutPreis] AS [CP.InPreis]
      EXIT_PROC
    END_IF

    CALL ConvertPrice2 [CP.InID], [CP.InPreis], 0.0, 0.0, [CP.OutID], 5, [CP.OutPreis], [CP.OutIsSystem], [CP.QRes]
  END_PROC
  ; Version 4.10.03 -



  ; Wird fr die Kasse bentigt
  PROCEDURE ConvertPriceShort VF CP.InPreis, VF CP.InFFaktor, VF CP.InSFaktor, ~VF CP.OutPreis, VF CP.OutFFaktor, VF CP.OutSFaktor
    IF [CP.InFFaktor]<[EPSILON]
      CALC [CP.InFFaktor] AS 1
    END_IF

    IF [CP.OutSFaktor]<[EPSILON]
      CALC [CP.OutSFaktor] AS 1
    END_IF

    CALC [CP.OutPreis] AS [CP.InPreis]/[CP.InFFaktor]*[CP.InSFaktor]/[CP.OutSFaktor]*[CP.OutFFaktor]
  END_PROC



  PROCEDURE Dezimal2String VF R.LocFloat, VN R.LocCntNachkomma, ~VS R.LocStr
    LOCAL_NUM   R.LocalTmpNum
    LOCAL_FLOAT R.LocalTmpFloat

    IF [R.LocCntNachkomma]>=0
      CALC [R.LocStr] AS [R.LocFloat|R0,[R.LocCntNachkomma]]
    ELSE
      CALC [R.LocalTmpNum]   AS INT([R.LocFloat])
      CALC [R.LocalTmpFloat] AS [R.LocFloat]-[R.LocalTmpNum]
      IF [R.LocalTmpFloat]>[EPSILON]
        ; NachKommastellen vorhanden
        CALC [R.LocalTmpNum] AS [R.LocCntNachkomma]*(-1)
        CALC [R.LocStr] AS [R.LocFloat|R0,[R.LocalTmpNum]]
      ELSE
        CALC [R.LocStr] AS [R.LocFloat|R0,0]
      END_IF
    END_IF
  END_PROC



  PROCEDURE BerechneVKPreise VF P.Menge, VF P.Preis, VF P.Rabatt1, VF P.Rabatt2, VF P.Rabatt3, VB P.IsBrutto, VF P.BWaehrungID, VF P.MwstPr, ~VF P.PEinheit
    LOCAL_BOOL LocRes
    IDENTIFIER_EXIST 'QRes',[LocRes]
    IF [LocRes]=FALSE
      VAR_BOOL QRes
    END_IF


    ; berechne die Preise und Gesamtpreise:
    ; rein geht Menge        P.Menge
    ;           Preis        P.Preis (BelegGrundPreis oder BelegGrundPreisB je nach IsBrutto)
    ;           RabattPr     P.Rabatt1
    ;           Rabatt2      P.Rabatt2
    ;           Rabatt3      P.Rabatt3
    ;           IsBrutto     P.IsBrutto
    ;           WaehrungID   P.BWaehrungID = BelegWaehrungID
    ;           MwstPr       P.MwstPr
    ;           PreisEinheit P.PEinheit
    ;

    ; berechnet wird BelegGrundpreis   P.BGN Belegwaehrung netto
    ;                BelegPreis        P.BPN
    ;                BelegGesamtpreis  P.BTN

    ;                GrundPreis        P.SGN Systemwaehrung netto
    ;                Preis             P.SPN
    ;                Gesamtpreis       P.STN

    ;                BelegGrundPreisB  P.BGB Belegwaehrung brutto
    ;                BelegPreisB       P.BPB
    ;                BelegGesamtpreisB P.BTB

    ;                GrundPreisB       P.SGB Systemwaehrung brutto
    ;                PreisB            P.SPB
    ;                GesamtpreisB      P.STB


    IDENTIFIER_EXIST 'BelegGrundpreis',[LocRes]
    IF [LocRes]=FALSE
      VAR_FLOAT BelegGrundpreis
    END_IF

    IDENTIFIER_EXIST 'BelegPreis',[LocRes]
    IF [LocRes]=FALSE
      VAR_FLOAT BelegPreis
    END_IF

    IDENTIFIER_EXIST 'BelegGesamtpreis',[LocRes]
    IF [LocRes]=FALSE
      VAR_FLOAT BelegGesamtpreis
    END_IF

    IDENTIFIER_EXIST 'GrundPreis',[LocRes]
    IF [LocRes]=FALSE
      VAR_FLOAT GrundPreis
    END_IF

    IDENTIFIER_EXIST 'Preis',[LocRes]
    IF [LocRes]=FALSE
      VAR_FLOAT Preis
    END_IF

    IDENTIFIER_EXIST 'Gesamtpreis',[LocRes]
    IF [LocRes]=FALSE
      VAR_FLOAT Gesamtpreis
    END_IF

    IDENTIFIER_EXIST 'BelegGrundPreisB',[LocRes]
    IF [LocRes]=FALSE
      VAR_FLOAT BelegGrundPreisB
    END_IF

    IDENTIFIER_EXIST 'BelegPreisB',[LocRes]
    IF [LocRes]=FALSE
      VAR_FLOAT BelegPreisB
    END_IF

    IDENTIFIER_EXIST 'BelegGesamtpreisB ',[LocRes]
    IF [LocRes]=FALSE
      VAR_FLOAT BelegGesamtpreisB
    END_IF

    IDENTIFIER_EXIST 'GrundPreisB',[LocRes]
    IF [LocRes]=FALSE
      VAR_FLOAT GrundPreisB
    END_IF

    IDENTIFIER_EXIST 'PreisB',[LocRes]
    IF [LocRes]=FALSE
      VAR_FLOAT PreisB
    END_IF

    IDENTIFIER_EXIST 'GesamtpreisB',[LocRes]
    IF [LocRes]=FALSE
      VAR_FLOAT GesamtpreisB
    END_IF

    IF [P.PEinheit]<[EPSILON]
      CALC [P.PEinheit] AS 1
    END_IF

    IF [P.IsBrutto]
      ; Bruttopreise
      CALC [BelegGrundpreisB] AS [P.Preis]
      CALC [BelegPreisB]      AS [P.Preis]

      IF [P.Rabatt1]>[EPSILON]
        CALC [BelegPreisB] AS [BelegPreisB]*(1-[P.Rabatt1]/100)
      END_IF

      IF [P.Rabatt2]>[EPSILON]
        CALC [BelegPreisB] AS [BelegPreisB]*(1-[P.Rabatt2]/100)
      END_IF

      IF [P.Rabatt3]>[EPSILON]
        CALC [BelegPreisB] AS [BelegPreisB]*(1-[P.Rabatt3]/100)
      END_IF

      CALC [BelegGesamtpreisB] AS [P.Menge]*[BelegPreisB]/[P.PEinheit]
      CALL RoundMoney [BelegGesamtpreisB]

      ; Systemnettowerte
      CALL ConvertPrice [P.BWaehrungID], [BelegPreisB],       [CURRENCY_ID], 1, 1, TRUE, [PreisB],       [QRes]
      CALL ConvertPrice [P.BWaehrungID], [BelegGrundpreisB],  [CURRENCY_ID], 1, 1, TRUE, [GrundpreisB],  [QRes]
      CALL ConvertPrice [P.BWaehrungID], [BelegGesamtpreisB], [CURRENCY_ID], 1, 1, TRUE, [GesamtpreisB], [QRes]
      CALL RoundMoney [GesamtpreisB]

      ; jetzt daraus die Nettopreise
      CALC [Preis]            AS [PreisB]/(1+[P.MwstPr]/100)
      CALC [GrundPreis]       AS [GrundpreisB]/(1+[P.MwstPr]/100)
      CALC [GesamtPreis]      AS [GesamtpreisB]/(1+[P.MwstPr]/100)
      CALC [BelegPreis]       AS [BelegPreisB]/(1+[P.MwstPr]/100)
      CALC [BelegGrundPreis]  AS [BelegGrundpreisB]/(1+[P.MwstPr]/100)
      CALC [BelegGesamtpreis] AS [BelegGesamtpreisB]/(1+[P.MwstPr]/100)

      CALL RoundMoney [GesamtPreis]
      CALL RoundMoney [BelegGesamtpreis]
    ELSE
      ; Nettopreise
      CALC [BelegGrundpreis] AS [P.Preis]
      CALC [BelegPreis]      AS [P.Preis]

      IF [P.Rabatt1]>[EPSILON]
        CALC [BelegPreis] AS [BelegPreis]*(1-[P.Rabatt1]/100)
      END_IF

      IF [P.Rabatt2]>[EPSILON]
        CALC [BelegPreis] AS [BelegPreis]*(1-[P.Rabatt2]/100)
      END_IF

      IF [P.Rabatt3]>[EPSILON]
        CALC [BelegPreis] AS [BelegPreis]*(1-[P.Rabatt3]/100)
      END_IF

      CALC [BelegGesamtpreis] AS [P.Menge]*[BelegPreis]/[P.PEinheit]
      CALL RoundMoney [BelegGesamtpreis]

      ; Systemnettowerte
      CALL ConvertPrice [P.BWaehrungID], [BelegPreis],       [CURRENCY_ID], 1, 1, TRUE, [Preis],       [QRes]
      CALL ConvertPrice [P.BWaehrungID], [BelegGrundpreis],  [CURRENCY_ID], 1, 1, TRUE, [Grundpreis],  [QRes]
      CALL ConvertPrice [P.BWaehrungID], [BelegGesamtpreis], [CURRENCY_ID], 1, 1, TRUE, [Gesamtpreis], [QRes]
      CALL RoundMoney [Gesamtpreis]

      CALC [PreisB]            AS [Preis]*(1+[P.MwstPr]/100)
      CALC [GrundPreisB]       AS [Grundpreis]*(1+[P.MwstPr]/100)
      CALC [GesamtPreisB]      AS [Gesamtpreis]*(1+[P.MwstPr]/100)
      CALC [BelegPreisB]       AS [BelegPreis]*(1+[P.MwstPr]/100)
      CALC [BelegGrundPreisB]  AS [BelegGrundpreis]*(1+[P.MwstPr]/100)
      CALC [BelegGesamtpreisB] AS [BelegGesamtpreis]*(1+[P.MwstPr]/100)

      CALL RoundMoney [GesamtPreisB]
      CALL RoundMoney [BelegGesamtpreisB]
    END_IF

    CALC [Rohgewinn] AS [Preis]-[EK]
    CALC [Rohgewinn] AS [Rohgewinn]*[P.Menge]
    CALC [Rohgewinn] AS [Rohgewinn]/[P.PEinheit]
    CALL RoundMoney [Rohgewinn]
  END_PROC



  PROCEDURE ConvertUnits VF LocArtikelID, ~VF LagerAnzahl, ~VF LocMenge, VS LocStr, VN LocDir
    IF [LocDir]=0
      CALC [LocMenge] AS [LagerAnzahl]
    ELSE_IF [LocDir]=1
      CALC [LagerAnzahl] AS [LocMenge]
    END_IF

    IF [LocArtikelID]<[EPSILON]
      EXIT_PROC
    END_IF
    IF [LocStr]='LG'
      EXIT_PROC
    END_IF

    LOCAL_BOOL  LocRes
    LOCAL_STR LocFormel
    LOCAL_STR LocFStr
    LOCAL_STR LocRStr
    LOCAL_QUERY LocQ
    LOCAL_FLOAT LocFormWert

    QUERY [LocQ]
      SELECT *
        FROM ARTIKEL
       WHERE RecordID = [LocArtikelID|R0,0]
    END_QUERY

    EXECUTE [LocQ],[LocRes]
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [LocQ],[LocRes]
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    CALC [LocFormWert] AS 0.0
    CALC [LocFormel] AS [LocQ!Formel[LocStr]]
    IF [LocFormel]=''
      MESSAGE 'Achtung!', 'Kein Formel Gefunden!'
      EXIT_PROC
    END_IF
    CALC [LocFStr]   AS '{'
    CALC [LocRStr]   AS CON([LocFStr],'[LocQ!')
    CALC [LocRStr]   AS '[LocQ!'
    CALC [LocFormel] AS REPLACE([LocFormel],[LocFStr],[LocRStr])
    CALC [LocFormel] AS REPLACE([LocFormel],'}',']')
    CALC [LocFormWert] AS [LocFormel]
    IF [LocFormWert]<>0
      IF [LocDir]=0
        CALC [LocMenge] AS [LocFormel]*[LagerAnzahl]
      ELSE_IF [LocDir]=1
          CALC [LagerAnzahl] AS [LocMenge]/([LocFormel])
      END_IF
    END_IF
  END_PROC



  PROCEDURE GetMonthName VD R.LocalDate, ~VS R.MonatUndJahr
    LOCAL_NUM LocStopDay
    LOCAL_NUM LocStopYear
    LOCAL_NUM LocStopMonth

    DATE_2_DMY [R.LocalDate],[LocStopDay],[LocStopMonth],[LocStopYear]
    CALC [R.MonatUndJahr] AS '000'

    IF [LocStopMonth]=1
      CALC [R.MonatUndJahr] AS 'Jan.'
    ELSE_IF [LocStopMonth]=2
      CALC [R.MonatUndJahr] AS 'Feb.'
    ELSE_IF [LocStopMonth]=3
      CALC [R.MonatUndJahr] AS 'Mrz'
    ELSE_IF [LocStopMonth]=4
      CALC [R.MonatUndJahr] AS 'Apr.'
    ELSE_IF [LocStopMonth]=5
      CALC [R.MonatUndJahr] AS 'Mai '
    ELSE_IF [LocStopMonth]=6
      CALC [R.MonatUndJahr] AS 'Juni'
    ELSE_IF [LocStopMonth]=7
      CALC [R.MonatUndJahr] AS 'Juli'
    ELSE_IF [LocStopMonth]=8
      CALC [R.MonatUndJahr] AS 'Aug.'
    ELSE_IF [LocStopMonth]=9
      CALC [R.MonatUndJahr] AS 'Sep.'
    ELSE_IF [LocStopMonth]=10
      CALC [R.MonatUndJahr] AS 'Okt.'
    ELSE_IF [LocStopMonth]=11
      CALC [R.MonatUndJahr] AS 'Nov.'
    ELSE_IF [LocStopMonth]=12
      CALC [R.MonatUndJahr] AS 'Dez.'
    END_IF

    CALC [R.MonatUndJahr] AS CON([R.MonatUndJahr],' ',[LocStopYear])
  END_PROC



  PROCEDURE ReadCSVFeldTrenner ~VS LocFeldTrenner
    LOCAL_BOOL  LocRes
    LOCAL_NUM   LocNum
    LOCAL_STR   LocStr
    LOCAL_STR   LocInfo

    CALC [LocStr] AS CON([PRINTSET_PATH],[STATION_SHORT],'.INI')
    INI_READ	[LocRes], [LocInfo], [SCRIPT_STRING], [LocStr], 'CSV_TRENNZEICHEN', 'IDEAL'

    IF [LocInfo]=''
      CALC [LocStr] AS CON([SPECIAL_PATH],'ideal.cfg')
      INI_READ	[LocRes], [LocInfo], [SCRIPT_STRING], [LocStr], 'CSV_TRENNZEICHEN', 'ALLGEMEIN'
    END_IF

    IF [LocInfo]=''
      CALC [LocInfo] AS '44'
    END_IF

    CALC [LocNum] AS VAL([LocInfo])

    CALC [LocFeldTrenner] AS CHAR(#[LocNum])
  END_PROC



  PROCEDURE DayInYear VD LocDate, ~VN LocDayNoInYear
    LOCAL_NUM   LocDay
    LOCAL_NUM   LocYear
    LOCAL_NUM   LocNum1
    LOCAL_NUM   LocNum2
    LOCAL_NUM   LocMonth
    LOCAL_DATE  LocTmpDate

    DATE_2_DMY [LocDate], [LocDay], [LocMonth], [LocYear]

    IF [LocMonth]=1
      CALC [LocDayNoInYear] AS [LocDay]
    ELSE
      CALC [LocNum1] AS 1
      CALC [LocNum2] AS 1
      DMY_2_DATE [LocNum1], [LocNum2], [LocYear], [LocTmpDate]

      CALC [LocDayNoInYear] AS 0

      CALC [LocNum2] AS 1
      WHILE [LocNum2]<[LocMonth]
        DAYS_IN_MONTH [LocTmpDate], [LocNum1]
        CALC [LocDayNoInYear] AS [LocDayNoInYear]+[LocNum1]

        CALC [LocTmpDate] AS [LocTmpDate]+M1
        INC [LocNum2]
      END_WHILE

      CALC [LocDayNoInYear] AS [LocDayNoInYear]+[LocDay]
    END_IF
  END_PROC



  PROCEDURE DateDiffTage VD LocFirstDate, VD LocLastDate, ~VN LocDiffInTagen
    LOCAL_BOOL  LocRes
    IDENTIFIER_EXIST 'DayNoInYear',[LocRes]
    IF [LocRes]=FALSE
      VAR_NUM DayNoInYear
    END_IF

    LOCAL_NUM   LocNum
    LOCAL_NUM   LocFirstDay
    LOCAL_NUM   LocFirstMonth
    LOCAL_NUM   LocFirstYear
    LOCAL_NUM   LocLastDay
    LOCAL_NUM   LocLastMonth
    LOCAL_NUM   LocLastYear

    LOCAL_DATE  LocDate

    ; ermittle den Tag im Jahr fr LocFirstDate

    DATE_2_DMY [LocFirstDate], [LocFirstDay], [LocFirstMonth], [LocFirstYear]
    DATE_2_DMY [LocLastDate],  [LocLastDay],  [LocLastMonth],  [LocLastYear]

    IF [LocFirstYear]=[LocLastYear]
      CALL DayInYear [LocFirstDate], [DayNoInYear]
      CALC [LocDiffInTagen] AS [DayNoInYear]

      CALL DayInYear [LocLastDate], [DayNoInYear]
      CALC [LocNum] AS [DayNoInYear]

      CALC [LocDiffInTagen] AS [LocNum]-[LocDiffInTagen]
      EXIT_PROC
    ELSE_IF [LocFirstYear]<[LocLastYear]
      CALL DayInYear [LocFirstDate], [LocDiffInTagen]
      IS_LEAP_YEAR [LocFirstYear], [LocRes]
      IF [LocRes]
        CALC [LocDiffInTagen] AS 366-[LocDiffInTagen]
      ELSE
        CALC [LocDiffInTagen] AS 365-[LocDiffInTagen]
      END_IF

      CALC [LocNum] AS [LocLastYear]-[LocFirstYear]
      IF [LocNum]>1
        CALC [LocNum] AS [LocFirstYear]+1
        WHILE [LocNum]<[LocLastYear]
          IS_LEAP_YEAR [LocFirstYear], [LocRes]
          IF [LocRes]
            CALC [LocDiffInTagen] AS [LocDiffInTagen]+366
          ELSE
            CALC [LocDiffInTagen] AS [LocDiffInTagen]+365
          END_IF

          INC [LocNum]
        END_WHILE

        CALL DayInYear [LocLastDate], [LocNum]
        CALC [LocDiffInTagen] AS [LocDiffInTagen]+[LocNum]
      END_IF
    ELSE

    END_IF
  END_PROC



  PROCEDURE GetZeitDiff VT LocVonZeit, VT LocBisZeit, ~VN LocMinDiff, ~VS LocStdMinStr
    ; berechnet die Zeit in Minuten und als Str im Format hh:mm zwischen LocBVonZeit und LocBisZeit

    LOCAL_NUM   LocNum
    LOCAL_NUM   LocSec
    LOCAL_NUM   LocMin
    LOCAL_NUM   LocStd

    TIME_2_HMS [LocVonZeit],[LocStd],[LocMin],[LocSec]
    CALC [LocNum] AS ([LocStd]*60)+[LocMin]

    TIME_2_HMS [LocBisZeit],[LocStd],[LocMin],[LocSec]
    CALC [LocMinDiff] AS ([LocStd]*60)+[LocMin]
    IF [LocMinDiff]<[LocNum]
      ; BisZeit vor VonZeit => BisZeit am Folgetage
      CALC [LocMinDiff] AS 1440+[LocMinDiff]-[LocNum]
    ELSE
      CALC [LocMinDiff] AS [LocMinDiff]-[LocNum]
    END_IF

    CALC [LocStd]       AS [LocMinDiff] DIV 60
    CALC [LocMin]       AS [LocMinDiff] MOD 60
    CALC [LocStdMinStr] AS [LocMin]

    IF [LocMin]<10
      IF [LocMin]=0
        CALC [LocStdMinStr] AS '00'
      ELSE
        CALC [LocStdMinStr] AS CON('0',[LocStdMinStr])
      END_IF
    END_IF

    CALC [LocStdMinStr] AS CON([LocStd], ':',[LocStdMinStr])
  END_PROC