
  PROCEDURE InitVars
    VAR_BOOL  Res
    VAR_STR   TmpStr
    VAR_QUERY SQ
    VAR_QUERY UQ
  END_PROC



  PROCEDURE CheckAndSaveOneRecord VS LocTableName, VF LocID
    QUERY [UQ]
      SELECT RecordID
        FROM [LocTableName]
       WHERE RecordID = [LocID|R0,0]
    END_QUERY

    EXECUTE [UQ],[Res]
    IF [Res]=FALSE
      CALC [TmpStr] AS CON('Die Prfung des Leer-Datensatzes der Tabelle "',[LocTableName],'" ist fehlgeschlagen.')
      MESSAGE 'Achtung',[TmpStr],[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [UQ],[Res]
    IF [Res]
      ; alles ok, raus
      EXIT_PROC
    END_IF

    NEW_RECORD [Res], [LocTableName], [LocID], FALSE, TRUE
    IF [Res]=FALSE
      CALC [TmpStr] AS CON('Der Leer-Datensatzes der Tabelle "',[LocTableName],'" konnte nicht angelegt werden.')
      MESSAGE 'Achtung',[TmpStr],[MESSAGE_ERROR]
    END_IF
  END_PROC


  PROCEDURE CheckCSHRecords
    ; checkt, ob es die notwendigen Records verschiedener Tabellen gibt oder wie

    QUERY [SQ]
      SELECT TableName, UseDefID, DefinedID
        FROM TableFld
       WHERE UseDefID = [SQL_BOOLEAN_QUOTATION][SQL_BOOLEAN_TRUE][SQL_BOOLEAN_QUOTATION]
    END_QUERY

    EXECUTE [SQ],[Res]
    IF [Res]=FALSE
      CALC [TmpStr] AS CON('Die Prfung der Tabellen mit Leer-Datenstzen "',[LocTableName],'" ist fehlgeschlagen.')
      MESSAGE 'Achtung',[TmpStr],[MESSAGE_ERROR]
      EXIT_PROC
    END_IF

    GET_DATA [SQ],[Res]
    WHILE [Res]
      CALL CheckAndSaveOneRecord [SQ!TableName], [SQ!DefinedID]
      GET_DATA [SQ],[Res]
    END_WHILE
  END_PROC



  PROCEDURE Main
    ; read cfg-file
    ; INI_READ alle mglichen CFG-Datei Werte

    ; Nach Prfung der CFG-Werte, sollten die evenetuell vernderten Werte wieder in die CFG zurck geschrieben werden
    SCRIPT 'Basis2022Write.csh'

    ; NUll-Records Prfen und ggf. einbauen...
    CALL CheckCSHRecords
  END_PROC



SCRIPT_BEGIN
  CALL InitVars
  CALL Main
SCRIPT_END
