   ; Parameters    RECORD_ID1 0 = MIT  Mandanten-Tabellen-Prfung
   ;                          1 = OHNE Mandanten-Tabellen-Prfung


   PROCEDURE InitVars
     VAR_QUERY Q
     VAR_BOOL  Res
     VAR_FLOAT Float1, 0
     VAR_STR   Str1,   ''
     VAR_NUM   YNRes
     VAR_BOOL  VirtDelBuf, [VIRTUAL_DELETE]
     CALC [VIRTUAL_DELETE] AS FALSE
   END_PROC



   PROCEDURE MandantsCreate
     QUERY [Q]
       DROP TABLE [SQL_IF_EXISTS] mandants
     END_QUERY
     EXECUTE [Q],[Res]

     QUERY [Q]
       CREATE TABLE mandants
           ( RecordID          [SQL_DEFINE_RECORDID]       [SQL_DEFINE_PRIMARY_KEY1],
             IDUser            [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
             LevelUser         [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
             Mandant           [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
             UpdateID          [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
             UpdateTime        [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
             RecFlag           [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
             EventFlag         [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
             VirtualDelID      [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END],
             VirtualDelUserIdx [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
             MandantIdx        [SQL_DEFINE_LONGINT]        [SQL_DEFINE_LONGINT_END],
             MandantName       [SQL_DEFINE_STRING]   (120) [SQL_DEFINE_STRING_END],
             AddressID         [SQL_DEFINE_RECORDID]       [SQL_DEFINE_RECORDID_END]
             [SQL_DEFINE_PRIMARY_KEY2]
             )
     END_QUERY
     EXECUTE [Q],[Res]

     QUERY [Q]
       CREATE UNIQUE INDEX IndMandaRecordID ON mandants (RecordID) [SQL_DEFINE_PRIMARY_KEY3]
     END_QUERY
     EXECUTE [Q],[Res]

     QUERY [Q]
       CREATE INDEX IndMandaVirtualDelID    ON mandants (VirtualDelID)
     END_QUERY
     EXECUTE [Q],[Res]

     QUERY [Q]
       CREATE INDEX IndMandaMandantIdx      ON mandants (MandantIdx)
     END_QUERY
     EXECUTE [Q],[Res]

     QUERY [Q]
       CREATE INDEX IndMandaMandantName     ON mandants (MandantName)
     END_QUERY
     EXECUTE [Q],[Res]

     QUERY [Q]
       CREATE INDEX IndMandaAddressID       ON mandants (AddressID)
     END_QUERY
     EXECUTE [Q],[Res]

     QUERY [Q]
       INSERT INTO mandants (RecordID,MandantName) VALUES (0,'');
     END_QUERY
     EXECUTE [Q],[Res]
   END_PROC



   PROCEDURE MandantsCheck
     QUERY [Q]
       SELECT RecordID FROM mandants
     END_QUERY

     EXECUTE [Q],[Res]
     IF [Res]=FALSE
       CALL MandantsCreate

       QUERY [Q]
         SELECT RecordID FROM mandants
       END_QUERY
       EXECUTE [Q],[Res]
       IF [Res]=FALSE
         EXIT_PROC
       END_IF
     END_IF

     LOCAL_NUM   LocIdx
     LOCAL_STR   LocName
     LOCAL_FLOAT LocID
     LOCAL_FLOAT LocTS

     FLAG_SET [Q!VIEW_FLAG], [BROWSER_FLAG_SET_UPDATE_TIME], FALSE
     FLAG_SET [Q!VIEW_FLAG], [BROWSER_FLAG_SET_USER],        FALSE

     ACT_REC_ID [LocTS]
     QUERY [Q]
       UPDATE mandants
          SET UpdateTime = [LocTS|R0,0],
              EventFlag  = 1
        WHERE RecordID   > 0
     END_QUERY
     EXECUTE [Q],[Res]

     CALC [LocIdx] AS 1
     WHILE [LocIdx]>0
       MANDANT [MANDANT_OPT_CHECK_IDX], [LocIdx], [LocName], [LocID]
       IF [LocIdx]>0
         QUERY [Q]
           SELECT RecordID, MandantIdx, MandantName, AddressID
             FROM mandants
            WHERE MandantIdx = [LocIdx]
         END_QUERY
         EXECUTE [Q],[Res]
         IF [Res]
           GET_DATA [Q],[Res]
           IF [Res]
             CALC [Float1] AS [Q!RecordID]
           ELSE
             NEW_RECORD [Res],'mandants', [Float1], FALSE, FALSE, FALSE
           END_IF
           IF [Res]
             QUERY [Q]
               UPDATE mandants
                  SET MandantIdx  =  [LocIdx],
                      MandantName = "[LocName]",
                      AddressID   =  [LocID],
                      EventFlag   =  0
               WHERE RecordID    =  [Float1|R0,0]
             END_QUERY
             EXECUTE [Q],[Res]
           END_IF
         END_IF

       INC [LocIDx]
       END_IF
     END_WHILE

     FLAG_SET [Q!VIEW_FLAG], [BROWSER_FLAG_SET_UPDATE_TIME], FALSE
     FLAG_SET [Q!VIEW_FLAG], [BROWSER_FLAG_SET_USER],        FALSE
     QUERY [Q]
       DELETE
         FROM mandants
        WHERE UpdateTime = [LocTS|R0,0]
          AND EventFlag  = 1
          AND RecordID   > 0
     END_QUERY
     EXECUTE [Q],[Res]
   END_PROC



   PROCEDURE Main
     IF [RECORD_ID1]<=[EPSILON]
       CALL MandantsCheck
     END_IF

     CALC [Str1] AS CON([APPLICATION_MACHINE_NAME],' / ',[APPLICATION_USER_NAME])

     QUERY [Q]
       SELECT RecordID, StationName
         FROM stationnames
        WHERE StationShort = "[STATION_SHORT]"
          AND UserSIDShort = "[USER_SID_SHORT]"
     END_QUERY

     EXECUTE [Q],[Res]
     IF [Res]=FALSE
       MESSAGE 'Achtung Abbruch','Der Stationsname kann nicht gelesen werden',[MESSAGE_ERROR]
       CARA_HALT
     END_IF

     GET_DATA [Q],[Res]
     IF [Res]
       CALC [Float1] AS [Q!RecordID]
     ELSE
       QUERY [Q]
         DELETE
           FROM stationnames
          WHERE StationShort = ""
            AND UserSIDShort = ""
       END_QUERY
       EXECUTE [Q],[Res]

       NEW_RECORD [Res],'stationnames',[Float1], TRUE, FALSE, FALSE
       IF [Res]=FALSE
         MESSAGE 'Achtung Abbruch','Es konnte kein neuer Stationsname angelegt werden',[MESSAGE_ERROR]
         CARA_HALT
       END_IF
     END_IF

     QUERY [Q]
       UPDATE stationnames
          SET StationName       = "[Str1]",
              StationIDStr      = "[STATION_ID|R0,0]",
              StationShort      = "[STATION_SHORT]",
              StationID         =  [STATION_ID|R0,0],
              UserSID           = "[USER_SID]",
              UserSIDShort      = "[USER_SID_SHORT]",
              Mandant           =  [ACT_MANDANT],
              VirtualDelID      =  0,
              VirtualDelUserIdx =  0
        WHERE RecordID          =  [Float1|R0,0]
     END_QUERY

     EXECUTE [Q],[Res]
     IF [Res]=FALSE
       QUERY [Q]
         DELETE
           FROM stationnames
          WHERE RecordID = [Float1|R0,0]
       END_QUERY
       EXECUTE [Q],[Res]

       DEBUG_INFO [Str1]
       DEBUG_INFO [STATION_ID|R0,0]
       DEBUG_INFO [STATION_SHORT]
       DEBUG_INFO [USER_SID]
       DEBUG_INFO [USER_SID_SHORT]
       DEBUG_INFO [ACT_MANDANT]

       MESSAGE 'Achtung Abbruch','Der Stationsname konnte nicht registriert werden',[MESSAGE_ERROR]
       CARA_HALT
     END_IF
   END_PROC


SCRIPT_BEGIN
  CALL InitVars
  CALL Main
  CALC [VIRTUAL_DELETE] AS [VirtDelBuf]
SCRIPT_END
