
  PROCEDURE InitVars
    VAR_BROWSER B
    VAR_BOOL    BRes

    VAR_STR     ActUserClause,       ''
    VAR_STR     ActTimeStampClause,  ''

    VAR_DATE    Yesterday
    VAR_FLOAT   ActualTimeStamp

    VAR_NUM     OpenDates
    VAR_NUM     LostDates
    VAR_NUM     LostDatesToday
    VAR_NUM     NextDates

    CONST_BOOL  SHOW_LIST_NO,  FALSE
    CONST_BOOL  SHOW_LIST_YES, TRUE

    CALC [Yesterday] AS [DATE]-1
    ACT_REC_ID [ActualTimeStamp]

    IF [ACT_MIT_ID]>[EPSILON]
      CALC [ActUserClause] AS CON(' AND NextProcessor = ',[ACT_MIT_ID|R0,0],' ')
    END_IF
  END_PROC


  PROCEDURE GetDates VB ShowList, VS Header, ~VN Counter
    QUERY_LOAD [B],[BRes],'DocMgr_1'
    IF [BRes]=FALSE
      EXIT_PROC
    END_IF

    EXECUTE [B],[BRes]
    IF [BRes]=FALSE
      EXIT_PROC
    END_IF

    QUERY_COUNT [B],[Counter]
    IF [Counter]=0
      EXIT_PROC
    END_IF

    IF [ShowList]=FALSE
      EXIT_PROC
    END_IF

    VIEW [B],[BRes],[Header]
  END_PROC


  PROCEDURE GetOpenDates
    CALC [ActTimeStampClause] AS CON(' AND I.NextProcessDate = ',[SQL_DATE_QUOTES_4_SELECT],[DATE|R0,[SQL_DATE_PICTURE_4_SELECT]],[SQL_DATE_QUOTES_4_SELECT],' ')
    CALL GetDates [SHOW_LIST_NO], 'Liste der aktuellen Termine', [OpenDates]
  END_PROC


  PROCEDURE GetLostDates
    CALC [ActTimeStampClause] AS CON(' AND I.NextProcessDate <= ',[SQL_DATE_QUOTES_4_SELECT],[Yesterday|R0,[SQL_DATE_PICTURE_4_SELECT]],[SQL_DATE_QUOTES_4_SELECT],' ')
    CALL GetDates [SHOW_LIST_NO], 'Liste der vergangenen Termine', [LostDates]
  END_PROC


  PROCEDURE GetLostDatesToday
    CALC [ActTimeStampClause] AS CON('AND I.NextProcessDTID < ',[ActualTimeStamp|R0,0],' AND I.NextProcessDate = ',[SQL_DATE_QUOTES_4_SELECT],[DATE|R0,[SQL_DATE_PICTURE_4_SELECT]],[SQL_DATE_QUOTES_4_SELECT],' ')
    CALL GetDates [SHOW_LIST_NO], 'Liste der vergangenen Termine', [LostDatesToday]
  END_PROC


  PROCEDURE GetNextDates
    CALC [ActTimeStampClause] AS CON(' AND I.NextProcessDate > ',[SQL_DATE_QUOTES_4_SELECT],[DATE|R0,[SQL_DATE_PICTURE_4_SELECT]],[SQL_DATE_QUOTES_4_SELECT],' ')
    CALL GetDates [SHOW_LIST_NO], 'Liste der zuknftigen Termine', [NextDates]
  END_PROC


  PROCEDURE Main                              
    WAIT_CURSOR TRUE

    CALL InitVars

    CALL GetOpenDates
    CALL GetLostDates
    CALL GetLostDatesToday
    CALL GetNextDates

    LOCAL_STR InfoStr

    IF [ACT_MIT_ID]>[EPSILON]
      IF [OpenDates]>0
        CALC [InfoStr] AS CON('Heute sind noch ',[OpenDates],' Termine von Ihnen offen.|')
      ELSE
        CALC [InfoStr] AS CON('Heute haben Sie keine Termine.|')
      END_IF

      IF [LostDatesToday]>0
        CALC [InfoStr] AS CON([InfoStr],'Davon haben Sie bereits ',[LostDatesToday],' Termine verpasst.||')
      END_IF
    ELSE
      IF [OpenDates]>0
        CALC [InfoStr] AS CON('Heute sind noch ',[OpenDates],' Termine offen.|')
      ELSE
        CALC [InfoStr] AS CON('Heute sind keine Termine vorhanden.|')
      END_IF

      IF [LostDatesToday]>0
        CALC [InfoStr] AS CON([InfoStr],'Davon wurden bereits ',[LostDatesToday],' Termine verpasst.||')
      END_IF
    END_IF

    IF [LostDates]>0
      CALC [InfoStr] AS CON([InfoStr],[LostDates],' Termine aus den vergangen Tagen sind noch zu erledigen.||')
    END_IF

    IF [NextDates]>0
      CALC [InfoStr] AS CON([InfoStr],'Eingetragen sind weitere ',[NextDates],' Termine.')
    END_IF     

    WAIT_CURSOR FALSE

    PANEL_INFO ''
    MESSAGE    'Termininfo',[InfoStr]
  END_PROC


SCRIPT_BEGIN
  CALL Main
SCRIPT_END
