  ; Legende: DD, 16.09.1999

  PROCEDURE SetUpGridQ
    LOCAL_STR FilterStr

    CALC [FilterStr] AS [NoteSearchMask!D.Text]

    IF [FilterStr]=''
      CALC [FilterStr] AS 'v^v^v^v^v^v^v^v^v^v^v^v^v'
    ELSE
      CALC [FilterStr] AS CON([SQL_WILD_CARD_MULTI],[FilterStr],[SQL_WILD_CARD_MULTI])
    END_IF

    QUERY [GridQ]
        SELECT NoteInfo,
               TableName,
               NoteID,
               NoteSegment,
               RelRecID,
               RecordID,
               RecFlag
          FROM Notes
         WHERE NoteInfo LIKE "[FilterStr]"
      ORDER BY RelRecID, NoteID, TableName, NoteSegment
    END_QUERY
    EXECUTE [GridQ], [GridQRes]

    GRID_SET [NoteSearchMask], 'D.Grid', [GridQ], [GridQRes], [GridOption]

  END_PROC


  PROCEDURE InitVars
    WAIT_CURSOR TRUE
    PANEL_INFO 'Initialisieren der Notiz-Such-Maske'
    VAR_MASK NoteSearchMask,'9301'
    PANEL_INFO ''
    WAIT_CURSOR FALSE

    VAR_STR     TmpStr

    VAR_QUERY   GridQ
    VAR_BOOL    GridQRes

    VAR_QUERY   TableFldQ
    VAR_BOOL    TableFldQRes

    VAR_QUERY   FieldQ
    VAR_BOOL    FieldQRes

    VAR_NUM     GridOption

    CALC [GridOption] AS [BROWSER_FLAG_ICON_OK]

    CALL SetUpGridQ

    CALC [NoteSearchMask!MASK_HOOK_POST_CLEAR]  AS 'PostClearHook'
    CALC [NoteSearchMask!MASK_HOOK_EXIT]        AS 'ExitHook'
    CALC [NoteSearchMask!MASK_HOOK_BUTTON]      AS 'ButtonHook'
    CALC [NoteSearchMask!MASK_HOOK_GRID_OK]     AS 'GridOk'
    CALC [NoteSearchMask!MASK_HOOK_KEY]         AS 'KeyHook'
    CALC [NoteSearchMask!MASK_HOT_KEY_LIST]     AS '13@1'

    CALC [GridQ!QUERY_HOOK_REC_CHANGE]          AS 'GridChange'
  END_PROC


  PROCEDURE PostClearHook
    CALL SetUpGridQ
  END_PROC


  PROCEDURE ButtonHook
    IF [NoteSearchMask!MASK_ACT_FIELD_ID]=93010600
      CALL SetUpGridQ
    ELSE_IF [NoteSearchMask!MASK_ACT_FIELD_ID]=93010250
      SCRIPT [TableFldQ!ExecScript], [GridQ!RelRecID]
    END_IF
  END_PROC                                           


  PROCEDURE KeyHook
    ; RETURN - Taste gedrckt
    IF [NoteSearchMask!MASK_ACT_KEY]=13
      CALL SetUpGridQ
    END_IF
  END_PROC                                           

  PROCEDURE ExitHook
    MASK_CLEAR [NoteSearchMask]
  END_PROC


  PROCEDURE FillMaskWithNoInfo
    CALC [NoteSearchMask!D.Tabelle] AS 'KEIN INFORMATIONEN VERFGBAR'
    CALC [NoteSearchMask!D.Datei]   AS ''
    CALC [NoteSearchMask!D.Bez1]    AS ''
    CALC [NoteSearchMask!D.Bez2]    AS ''
    CALC [NoteSearchMask!D.Bez3]    AS ''
    CALC [NoteSearchMask!D.Bez4]    AS ''

    SET_LABEL [NoteSearchMask],'93010660','Info 1'
    SET_LABEL [NoteSearchMask],'93010670','Info 2'
    SET_LABEL [NoteSearchMask],'93010680','Info 3'
    SET_LABEL [NoteSearchMask],'93010690','Info 4'

    MASK_UPDATE [NoteSearchMask]

    FIELD_FLAG_ON_OFF [NoteSearchMask], '93010250', '[FIELD_FLAG_HIDDEN]', ''
  END_PROC


  PROCEDURE FillMaskWithFieldInfo
    CALC [NoteSearchMask!D.Tabelle] AS [TableFldQ!Name]
    CALC [NoteSearchMask!D.Datei]   AS [GridQ!TableName]
    CALC [NoteSearchMask!D.Bez1]    AS [FieldQ![TableFldQ!FieldName1]]
    CALC [NoteSearchMask!D.Bez2]    AS [FieldQ![TableFldQ!FieldName2]]
    CALC [NoteSearchMask!D.Bez3]    AS [FieldQ![TableFldQ!FieldName3]]
    CALC [NoteSearchMask!D.Bez4]    AS [FieldQ![TableFldQ!FieldName4]]

    SET_LABEL [NoteSearchMask],'93010660',[TableFldQ!FieldName1]
    SET_LABEL [NoteSearchMask],'93010670',[TableFldQ!FieldName2]
    SET_LABEL [NoteSearchMask],'93010680',[TableFldQ!FieldName3]
    SET_LABEL [NoteSearchMask],'93010690',[TableFldQ!FieldName4]

    MASK_UPDATE [NoteSearchMask]
                                
    IF [TableFldQ!ExecScript]<>''
      FIELD_FLAG_ON_OFF [NoteSearchMask], '93010250', '', '[FIELD_FLAG_HIDDEN]'
    ELSE
      FIELD_FLAG_ON_OFF [NoteSearchMask], '93010250', '[FIELD_FLAG_HIDDEN]', ''
    END_IF
  END_PROC


  PROCEDURE GridChange
    LOCAL_BOOL LocGoOn
    LOCAL_STR  LocTableAlias
    LOCAL_STR  LocFndStr
    LOCAL_STR  LocFilterStr
    LOCAL_STR  LocQueryStr
    LOCAL_NUM  LocFndPos

    CALC [LocGoOn]       AS TRUE
    CALC [LocTableAlias] AS COPY([GridQ!TableName],1,1)
    CALC [LocFndStr]     AS CON([GridQ!TableName],' ',[LocTableAlias])
    CALC [LocFndStr]     AS UPCASE([LocFndStr])

    QUERY [TableFldQ]
      SELECT Name,
             FieldName1,
             FieldName2,
             FieldName3,
             FieldName4,
             ExecScript,
             FieldQuery
        FROM TableFld
       WHERE TableName = "[GridQ!TableName]"
    END_QUERY

    EXECUTE [TableFldQ], [TableFldQRes]
    IF [TableFldQRes]=FALSE
      CALL FillMaskWithNoInfo
      EXIT_PROC
    END_IF

    GET_DATA [TableFldQ], [TableFldQRes]
    IF [TableFldQRes]=FALSE
      CALL FillMaskWithNoInfo
      EXIT_PROC
    END_IF

    WHILE [LocGoOn]
      CALC [LocFilterStr] AS ''
      CALC [LocQueryStr]  AS CON('SELECT * FROM ',[GridQ!TableName])

      IF [TableFldQ!FieldQuery]<>''
        CALC [LocQueryStr] AS [TableFldQ!FieldQuery]
      END_IF

      CALC [LocQueryStr] AS UPCASE([LocQueryStr])
      CALC [LocFndPos]   AS POS([LocFndStr],[LocQueryStr])

      IF [LocFndPos]>0
        CALC [LocFilterStr] AS CON([LocTableAlias],'.RecordID = ',[GridQ!RelRecID|R0,0])
      ELSE
        CALC [LocFilterStr] AS CON('RecordID = ',[GridQ!RelRecID|R0,0])
      END_IF

      QUERY [FieldQ]
        [LocQueryStr]
      END_QUERY
      QUERY_ADD_WHERE [FieldQ],255,[LocFilterStr]
      EXECUTE [FieldQ], [FieldQRes]
      IF [FieldQRes]
        GET_DATA [FieldQ], [FieldQRes]
        IF [FieldQRes]
          CALL FillMaskWithFieldInfo
          CALC [LocGoOn] AS FALSE
          EXIT_PROC
        END_IF
      END_IF

      GET_DATA [TableFldQ], [TableFldQRes]
      IF [TableFldQRes]=FALSE
        CALL FillMaskWithNoInfo
        CALC [LocGoOn] AS FALSE
        EXIT_PROC
      END_IF
    END_WHILE
  END_PROC


  PROCEDURE GridOk
  	NOTE_SHOW [GridQ!TableName], [GridQ!NoteID], [GridQ!RelRecID]
  END_PROC


SCRIPT_BEGIN
  CALL InitVars

  MASK_PROCESS [NoteSearchMask]
SCRIPT_END

