  ; ***************************************************************************
  ;
  ; Beschreibung : Ausdruck einer Termin- und Dokumentenelgende
  ;
  ; Legende      : Version 4.2.145 vom 20.10.2001 (GH)
  ;                Written by : GH, 20.10.2001
  ;
  ; Resourcen    : PrintOut.inc, Routines.inc
  ;
  ; Aufrufe      : Men Stammdaten / Mitarbeiter, rechte Maustaste
  ;                                / Interessenten, rechte Maustaste
  ;                                / Report, Terminliste
  ;
  ; ***************************************************************************



  INCLUDE Routines.INC
    ; importiert PROCEDURE RoundMoney ~VF RndVal


  INCLUDE PrintOut.INC
    ;   importiert : PROCEDURE PrintOut.OutPut VS PrintOut.PrintVar,          Name der Druck-Job-Variablen
    ;                                          VN PrintOut.Copies,            Anzahl der gewnschten Kopien
    ;                                          VS PrintOut.CFGFileName,       Max. vier Buchstaben zum identifizieren des Druck-Jobs
    ;                                          VN PrintOut.DefaultMode,       IDEAL-Parameter, der normalerweise die Ausgebeart beschreibt
    ;                                          VN PrintOut.ActualMode         User-Eingabe fr die Ausgabeart (z.B. [RECORD ID2])




  PROCEDURE InitVars
    VAR_BOOL  QRes

    VAR_NUM   Y
    VAR_NUM   xPos
    VAR_NUM   YNRes
    VAR_NUM   PageNo
    VAR_NUM   NoteLnAct
    VAR_NUM   NoteLnCnt
    VAR_NUM   MaxYOnPage,   2650
    VAR_NUM   StartYOnPage,  300
    VAR_NUM   Zeilenabstand,  37

    VAR_DATE  TmpDate

    VAR_STR   PrnStr
    VAR_STR   TmpStr
    VAR_STR   StrSign
    VAR_STR   PrintTitle

    VAR_QUERY SQ

    VAR_LIST  Note

    VAR_PRINT Prn
    ; if you want to print on other format, define the virtual papersize as follows
    ; recognize that you then have to set MaxYOnPage to some other value
    ; VAR_PRINT Prn, 2050, 3100

    CALC [StrSign]    AS CHAR(#39)
    CALC [PrintTitle] AS CON('Termin- / Dokumenten - Legende ',[DATE|R10,dd.mm.yy])
  END_PROC



  PROCEDURE LF ~VN ActY, VN Count
    IF [Count]=0
      CALC [Count] AS 1
    END_IF

    CALC [ActY] AS [ActY] + ([Zeilenabstand] * [Count])
  END_PROC



  PROCEDURE PrintAdresse
    LOCAL_BOOL  LocRes
    LOCAL_QUERY LocQ

    QUERY [LocQ]
      SELECT Kundennummer, Name1, Name2, Land, PLZ, Strasse, Ort, Telefon1, Fax1, EMail1
        FROM ADRESSEN
       WHERE RecordID = [RECORD_ID1|R0,0]
    END_QUERY

    EXECUTE [LocQ],[LocRes]
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [LocQ],[LocRes]
    IF [LocRes]=FALSE
      EXIT_PROC
    END_IF

    IF [LocQ!Kundennummer]<>''
      PRINT_BOX [Prn], 200, [Y],  450, [PRINT_POS_FREE], '[J L]', 'Kunden-Nr'
      PRINT_BOX [Prn], 450, [Y], 2000, [PRINT_POS_FREE], '[J L]', [LocQ!Kundennummer]
      PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
    END_IF

    IF [LocQ!Name1]<>''
      PRINT_BOX [Prn], 200, [Y],  450, [PRINT_POS_FREE], '[J L]', 'Name'
      PRINT_BOX [Prn], 450, [Y], 2000, [PRINT_POS_FREE], '[J L]', [LocQ!Name1]
      PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]

      PRINT_BOX [Prn], 450, [Y], 2000, [PRINT_POS_FREE], '[J L]', [LocQ!Name2]
      PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
    END_IF

    IF [LocQ!Ort]<>''
      PRINT_BOX [Prn], 200, [Y],  450, [PRINT_POS_FREE], '[J L]', 'Anschrift'

      IF [LocQ!Strasse]<>''
        PRINT_BOX [Prn], 450, [Y], 2000, [PRINT_POS_FREE], '[J L]', [LocQ!Strasse]
        PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
      END_IF

      CALC [PrnStr] AS ''

      IF [LocQ!Land]<>''
        IF [LocQ!Land]<>'D'
          IF [LocQ!Land]<>'DE'
            IF [LocQ!Land]<>'DEU'
              CALC [PrnStr] AS [LocQ!Land]
            END_IF
          END_IF
        END_IF
      END_IF

      IF [PrnStr]=''
        CALC [PrnStr] AS CON([LocQ!PLZ], ' ', [LocQ!Ort])
      ELSE
        CALC [PrnStr] AS CON([PrnStr],' ',[LocQ!PLZ], ' ', [LocQ!Ort])
      END_IF

      PRINT_BOX [Prn], 450, [Y], 2000, [PRINT_POS_FREE], '[J L]', [PrnStr]
      PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
    END_IF

    IF [LocQ!Telefon1]<>''
      PRINT_BOX [Prn], 200, [Y],  450, [PRINT_POS_FREE], '[J L]', 'Telefon'
      PRINT_BOX [Prn], 450, [Y], 2000, [PRINT_POS_FREE], '[J L]', [LocQ!Telefon1]
      PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
    END_IF

    IF [LocQ!Fax1]<>''
      PRINT_BOX [Prn], 200, [Y],  450, [PRINT_POS_FREE], '[J L]', 'Fax'
      PRINT_BOX [Prn], 450, [Y], 2000, [PRINT_POS_FREE], '[J L]', [LocQ!Fax1]
      PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
    END_IF

    IF [LocQ!EMail1]<>''
      PRINT_BOX [Prn], 200, [Y],  450, [PRINT_POS_FREE], '[J L]', 'E-Mail'
      PRINT_BOX [Prn], 450, [Y], 2000, [PRINT_POS_FREE], '[J L]', [LocQ!EMail1]
      PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
    END_IF

    CALL LF [Y], 1

    PRINT_BOX [Prn], 200, [Y], 2000, [PRINT_POS_FREE], '[J L]', 'Legende fr Art: T = offener Termin (Fettdruck), E = erledigter Termin, N = nur Notiz, D = Dokument hinterlegt.'
    PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
    PRINT_BOX [Prn], 200, [Y], 2000, [PRINT_POS_FREE], '[J L]', 'Legende fr Info: N = Notiz, D = Dokument, A = Adresse, A = andere Relation, N = Angebot, U = Auftrag.'
    PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
    CALL LF [Y], 1
  END_PROC



  PROCEDURE SeitenKopf
    CALC [Y] AS [StartYOnPage]-50

    PRINT_STR  [Prn], 200, [Y], '[N ',[StrSign],'Arial',[StrSign],' S 7]',[IP_FIRMEN_KUERZEL]

    CALC [PrnStr] AS CON('[N ',[StrSign],'Arial',[StrSign],' PS 0 S 8 J R]Seite ',[PageNo])
    PRINT_BOX  [Prn], 1700, [Y], -300, [PRINT_POS_FREE], [PrnStr]

    IF [PageNo]=1
      CALC [PrnStr] AS CON('[N ',[StrSign],'Arial',[StrSign],' PS 0 S 12 B J CE]',[PrintTitle])

      PRINT_BOX  [Prn], 200, [Y], -1900, [PRINT_POS_FREE], [PrnStr]
    ELSE
      CALC [PrnStr] AS CON('[N ',[StrSign],'Arial',[StrSign],' PS 0 S 10 B J CE]',[PrintTitle])
      PRINT_BOX  [Prn], 200, [Y], -1900, [PRINT_POS_FREE], [PrnStr]
    END_IF

    CALC [Y] AS [StartYOnPage]
    PRINT_LINE [Prn], 200, [Y], 2000, [Y]

    CALC [Y] AS [StartYOnPage]+50
    PRINT_STR  [Prn], 2000, [Y], '[T BO PS 0 J L]'

    IF [PageNo]=1
      CALL PrintAdresse
    END_IF
  END_PROC



  PROCEDURE PrintHeadlineList
    ; the headline
    PRINT_STR  [Prn], 2000, [Y], '[TO BC LtGray PC Black PS 2 B ] '

    PRINT_BOX  [Prn],  200, [Y],  300, [PRINT_POS_FREE], '[J L]',  'Art'
    PRINT_BOX  [Prn],  300, [Y],  600, [PRINT_POS_FREE], '[J L]',  'Termin'
    PRINT_BOX  [Prn],  600, [Y],  900, [PRINT_POS_FREE], '[J L]',  'Mitarbeiter'
    PRINT_BOX  [Prn],  900, [Y], 1000, [PRINT_POS_FREE], '[J CE]', 'Info'
    PRINT_BOX  [Prn], 1000, [Y], 2000, [PRINT_POS_FREE], '[J L]',  'Beschreibung'

    PRINT_STR  [Prn], 2000, [Y], '[T BO PS 0 J L] '
    CALL LF [Y], 2
  END_PROC



  PROCEDURE CheckAndDoUebertrag
    IF [Y]<[MaxYOnPage]
      EXIT_PROC
    END_IF

    PRINT_PAGE [Prn]

    CALC [YNRes] AS 0

    INC [PageNo]

    CALL SeitenKopf

    CALL PrintHeadlineList
  END_PROC



  PROCEDURE PrintOneNote VS NTabelle, VF NID, VN NType
    NOTE_READ [Note],[QRes],[NTabelle],[NType],[NID]
    IF [QRes]=FALSE
      EXIT_PROC
    END_IF

    LIST_ITEM_GET [Note],[NoteLnAct],[NoteLnCnt]
    IF [NoteLnCnt]<=0
      EXIT_PROC
    END_IF

    PRINT_BOX [Prn], 900, [Y], 1000, [PRINT_POS_FREE], '[J CE]', 'N'

    CALC [NoteLnAct] AS 1
    WHILE [NoteLnAct]<=[NoteLnCnt]
      LIST_STR_GET [Note],[PrnStr],[NoteLnAct]
      IF [PrnStr]<>''
        PRINT_BOX [Prn], 1010, [Y], 2000, [PRINT_POS_FREE], '[J L]', [PrnStr]
        PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
        CALL CheckAndDoUebertrag
      END_IF
      INC [NoteLnAct]
    END_WHILE

    ;CALL LF [Y], 1
  END_PROC



  PROCEDURE PrintOneRelationLine VS LocPrnLine
    IF [LocPrnLine]=''
      EXIT_PROC
    END_IF

    PRINT_BOX [Prn], [xPos], [Y], 2000, [PRINT_POS_FREE], '[J L]', [LocPrnLine]
    PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
    CALL CheckAndDoUebertrag
  END_PROC



  PROCEDURE PrintRelation
    IF [SQ!I.XRef07ID]<[EPSILON]
      EXIT_PROC
    END_IF

    ;CALL LF [Y], 1

    CALC [TmpStr] AS UPCASE([SQ!I.XRef07Name])
    IF [TmpStr]<>'ADRESSEN'
      IF [TmpStr]<>'AUFTRAG'
        PRINT_BOX [Prn], 900, [Y], 1000, [PRINT_POS_FREE], '[J CE]', 'AR'
        PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
        CALL CheckAndDoUebertrag
        EXIT_PROC
      END_IF
    END_IF

    LOCAL_BOOL  LocQRes
    LOCAL_QUERY LocQ

    IF [TmpStr]='ADRESSEN'
      QUERY [LocQ]
        SELECT Name1, Name2, PLZ, Ort, Telefon1
          FROM ADRESSEN
         WHERE RecordID = [SQ!I.XRef07ID|R0,0]
      END_QUERY

      EXECUTE [LocQ],[LocQRes]
      IF [LocQRes]=FALSE
        EXIT_PROC
      END_IF

      GET_DATA [LocQ],[LocQRes]
      IF [LocQRes]=FALSE
        EXIT_PROC
      END_IF

      PRINT_BOX [Prn], 900, [Y], 1000, [PRINT_POS_FREE], '[J CE]', 'A'
      CALL PrintOneRelationLine [LocQ!Name1]
      CALL PrintOneRelationLine [LocQ!Name2]
      CALC [PrnStr] AS CON([LocQ!PLZ], ' ', [LocQ!Ort])
      CALL PrintOneRelationLine [PrnStr]
      CALL PrintOneRelationLine [LocQ!Telefon1]
    ELSE_IF [TmpStr]='AUFTRAG'
      QUERY [LocQ]
        SELECT A.Auftragsnummer, A.Angebotsnummer, A.FertByte, A.Kurztext1, A.Kurztext2,
               K.Name1, K.Name2, K.Telefon1
          FROM AUFTRAG A, ADRESSEN K
         WHERE A.RecordID = [SQ!I.XRef07ID|R0,0]
           AND A.KundenID = K.RecordID
      END_QUERY

      EXECUTE [LocQ],[LocQRes]
      IF [LocQRes]=FALSE
        EXIT_PROC
      END_IF

      GET_DATA [LocQ],[LocQRes]
      IF [LocQRes]=FALSE
        EXIT_PROC
      END_IF

      IF [LocQ!A.FertByte]=-1
        PRINT_BOX [Prn], 900, [Y], 1000, [PRINT_POS_FREE], '[J CE]', 'G'
        CALL PrintOneRelationLine [LocQ!A.Angebotsnummer]
        CALL PrintOneRelationLine [LocQ!A.Kurztext1]
        CALL PrintOneRelationLine [LocQ!A.Kurztext2]
        CALL PrintOneRelationLine [LocQ!K.Name1]
        CALL PrintOneRelationLine [LocQ!K.Name2]
        CALL PrintOneRelationLine [LocQ!K.Telefon1]
      ELSE_IF [LocQ!A.FertByte]=0
        PRINT_BOX [Prn], 900, [Y], 1000, [PRINT_POS_FREE], '[J CE]', 'U'
        CALL PrintOneRelationLine [LocQ!A.Auftragsnummer]
        CALL PrintOneRelationLine [LocQ!A.Kurztext1]
        CALL PrintOneRelationLine [LocQ!A.Kurztext2]
        CALL PrintOneRelationLine [LocQ!K.Name1]
        CALL PrintOneRelationLine [LocQ!K.Name2]
        CALL PrintOneRelationLine [LocQ!K.Telefon1]
      END_IF
    END_IF
  END_PROC



  PROCEDURE Terminliste
    CALC [TmpStr] AS ''

    QUERY [SQ]
      SELECT I.NextProcessDate, I.NextProcessTime,
             I.ItemNote, H.FileName,
             I.CreateDate, I.CreateTime,
             I.HeaderID, I.RightActionLevel,
             I.NextProcessType, I.NextProcessDuranceID,
             I.CreatorID, I.CreateDTID, I.FilePath,
             I.FinishDate, I.FinishTime, I.FinishDuranceID,
             A.Name1, A.Name2,
             I.NextProcessorID, I.NextProcessDTID,
             I.FinishDTID, I.FinisherID, I.FinishType,
             I.XRef07Name, I.XRef07ID,
             H.RelRecID, H.TableName,
             I.RecordID, I.RecFlag
        FROM DOCMGRH H, DOCMGRI I, ADRESSEN A
       WHERE H.RelRecID = [RECORD_ID1|R0,0]
         AND I.HeaderID  = H.RecordID
         AND I.HeaderID  > 0
         AND I.FinisherID = A.RecordID
       ORDER BY I.FinishDate, FinishTime
    END_QUERY

    EXECUTE [SQ],[QRes]
    IF [QRes]=FALSE
      EXIT_PROC
    END_IF

    GET_DATA [SQ],[QRes]

    WHILE [QRes]
      CALC [PrnStr] AS CON([SQ!I.FinishDate|R8,dd.mm.yy], ', ',[SQ!I.FinishTime|R5,hh:mm])
      IF [SQ!I.NextProcessDuranceID]>[EPSILON]
        IF [SQ!I.FinishDuranceID]<[EPSILON]
          ; offener Termin
          PRINT_BOX [Prn],  310, [Y], 600, [PRINT_POS_FREE], '[N B J L]', [PrnStr]
        ELSE
          PRINT_BOX [Prn],  310, [Y], 600, [PRINT_POS_FREE], '[J L]', [PrnStr]
        END_IF
      ELSE
        PRINT_BOX [Prn],  310, [Y], 600, [PRINT_POS_FREE], '[J L]', [PrnStr]
      END_IF

      ; falls der Mitarbeiter-Name ber mehrere Zeilen geht
      CALC [YNRes] AS [Y]

      CALC [PrnStr] AS [SQ!A.Name1]
      IF [SQ!A.Name2]<>''
        CALC [PrnStr] AS CON([PrnStr],' ',[SQ!A.Name2])
      END_IF

      PRINT_BOX  [Prn], 610, [Y],  900, [PRINT_POS_FREE], '[J L]', [PrnStr]
      PRINT_POS [Prn], [YNRes], [PRINT_POS_BOTTOM]

      IF [SQ!I.NextProcessDuranceID]>[EPSILON]
        ; es ist ein Termin
        IF [SQ!I.FinishDuranceID]>[EPSILON]
          IF [SQ!I.FilePath]<>''
            CALC [PrnStr] AS 'E, D'
          ELSE
            CALC [PrnStr] AS 'E'
          END_IF
        ELSE
          IF [SQ!I.FilePath]<>''
            CALC [PrnStr] AS 'T, D'
          ELSE
            CALC [PrnStr] AS 'T'
          END_IF
        END_IF
      ELSE
        IF [SQ!I.FilePath]<>''
          CALC [PrnStr] AS 'D'
        ELSE
          CALC [PrnStr] AS 'N'
        END_IF
      END_IF

      PRINT_BOX  [Prn], 210, [Y], 300, [PRINT_POS_FREE], '[J L]', [PrnStr]

      CALC [xPos] AS 1010

      PRINT_BOX [Prn], 1010, [Y], 2000, [PRINT_POS_FREE], '[J L]', [SQ!I.ItemNote]
      PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]

      IF [YNRes]>[Y]
        CALC [Y] AS [YNRes]
      END_IF

      IF [SQ!I.FinishType]<>''
        IF [SQ!I.FinishType]<>[SQ!I.ItemNote]
          PRINT_BOX [Prn], 1010, [Y], 2000, [PRINT_POS_FREE], '[J L]', [SQ!I.FinishType]
          PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
        END_IF
      END_IF

      IF [SQ!I.FilePath]<>''
        PRINT_BOX [Prn],  900, [Y], 1000, [PRINT_POS_FREE], '[J CE]', 'D'
        PRINT_BOX [Prn], 1010, [Y], 2000, [PRINT_POS_FREE], '[J L]',  [SQ!I.FilePath]
        PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]
      END_IF

      CALL CheckAndDoUebertrag

      CALL PrintRelation
      PRINT_POS [Prn], [Y], [PRINT_POS_BOTTOM]

      CALL PrintOneNote 'DOCMGRI', [SQ!I.RecordID], 1
      CALL PrintOneNote 'DOCMGRI', [SQ!I.RecordID], 2
      CALL PrintOneNote 'DOCMGRI', [SQ!I.RecordID], 3
      CALL PrintOneNote 'DOCMGRI', [SQ!I.RecordID], 4

      GET_DATA [SQ],[QRes]

      IF [QRes]
        CALL LF [Y], 1
        CALL CheckAndDoUebertrag
      END_IF
    END_WHILE
  END_PROC



  PROCEDURE PrintIt
    CALC [PageNo] AS 1
    PRINT_CLR [Prn]

    WAIT_INFO 'Bitte warten.','Die Termin- / Dokumenten - Legende wird gedruckt ...'

    CALL Seitenkopf

    CALL PrintHeadlineList

    CALL Terminliste

    END_WAIT

    CALL PrintOut.OutPut 'Prn', 1, 'SPAU', [IP_PRINT_OUT_STATISTIC], 0
  END_PROC



SCRIPT_BEGIN
  CALL InitVars

  CALL PrintIt
SCRIPT_END


