  PROCEDURE GenGlobVars
    LOCAL_QUERY LocQ
    LOCAL_BOOL  LocQRes
    LOCAL_STR   LocAppHeader

    VAR_STR     CRLF
    VAR_DATE    GlobDefaultDate

    VAR_STR     PROGRAM_VERSION, '1.0.22'
    VAR_STR     CONFIG_FILE
    VAR_STR     CONFIG_FILE_MSK
    VAR_STR     CONFIG_FILE_XLS
    VAR_STR     APPLICATION_SHORT
    VAR_STR     USER_REAL_NAME
    VAR_STR     USER_PIN_CODE

    CALC [GlobDefaultDate]  AS '01.01.1980'
    CALC [CRLF]             AS CHAR(#13#10)

    CALC [CONFIG_FILE]      AS CON([PRINTSET_PATH],'Basis.cfg')

    IDENTIFIER_EXIST 'STATION_INI_FILE',[LocQRes]
    IF [LocQRes]=FALSE
      VAR_STR STATION_INI_FILE
    END_IF

    IF [STATION_INI_FILE]=''
      CALC [STATION_INI_FILE] AS CON([PRINTSET_PATH],[STATION_SHORT])
      IF [USER_SID_SHORT]<>''
        CALC [STATION_INI_FILE] AS CON([STATION_INI_FILE],'_',[USER_SID_SHORT])
      END_IF
      IF [SCREEN_IDX]<>''
        CALC [STATION_INI_FILE] AS CON([STATION_INI_FILE],'_',[SCREEN_IDX])
      END_IF
      CALC [STATION_INI_FILE] AS CON([STATION_INI_FILE],'.INI')

      CALC [STATION_INI_FILE] AS LOWCASE([STATION_INI_FILE])
    END_IF

    INI_READ	[LocQRes], [PROGRAM_VERSION],   [SCRIPT_STRING],  [CONFIG_FILE], 'VERSION',  'Allgemein'
    INI_READ	[LocQRes], [APPLICATION_SHORT], [SCRIPT_STRING],  [CONFIG_FILE], 'APP_NAME', 'Allgemein'

    IF [ACT_MIT_ID]>[EPSILON]
      QUERY [LocQ]
        SELECT Name1, UserPWD
          FROM adressen
         WHERE RecordID = [ACT_MIT_ID|R0,0]
      END_QUERY
      EXECUTE [LocQ], [LocQRes]
      IF [LocQRes]
        GET_DATA [LocQ], [LocQRes]
        IF [LocQRes]
          CALC [USER_REAL_NAME] AS [LocQ!Name1]
          CALC [USER_PIN_CODE]  AS [LocQ!UserPWD]
        END_IF
      END_IF
    END_IF

    CALC [LocAppHeader] AS CON([APPLICATION_NAME],' ',[PROGRAM_VERSION])

    IF [USER_SID_SHORT]<>''
      CALC [LocAppHeader] AS CON([LocAppHeader],'        (Station: ',[STATION_SHORT],'   SID: ',[USER_SID_SHORT])
    ELSE
      CALC [LocAppHeader] AS CON([LocAppHeader],'        (Station: ',[STATION_SHORT])
    END_IF
    CALC [LocAppHeader] AS CON([LocAppHeader],'   User: ',[SHORT_NAME])

    IF [ACT_MIT_ID]>[EPSILON]
      CALC [LocAppHeader] AS CON([LocAppHeader],'   Name: ',[USER_REAL_NAME])
    END_IF
    CALC [LocAppHeader] AS CON([LocAppHeader],'   Idx: ',[ACT_USER_ID],')')

    SET_MAIN_HEADER [LocAppHeader]
  END_PROC


  PROCEDURE Main
    CALL GenGlobVars

    ; Liest die CFG-Datei (wenn vorhanden) und schreibt die Null-records (wenn ntig)
    SCRIPT 'Basis2022Read.csh'
  END_PROC


SCRIPT_BEGIN
  CALL Main
SCRIPT_END