    ;   exportiert : PROCEDURE PrintOut.OutPut        VS PrintOut.PrintVar,              Name der Druck-Job-Variablen
    ;                                                 VN PrintOut.Copies,                Anzahl der gewnschten Kopien
    ;                                                 VS PrintOut.CFGFileName,           Max. vier Buchstaben zum identifizieren des Druck-Jobs
    ;                                                 VN PrintOut.DefaultMode,           IDEAL-Parameter, der normalerweise die Ausgebeart beschreibt
    ;                                                 VN PrintOut.ActualMode             User-Eingabe fr die Ausgabeart (z.B. [RECORD ID2])
    ;
    ;                Uses VPE-Dialog, loads the dialog if needed
    ;
    ;
    ;
    ;
    ;                PROCEDURE PrintOut.GetSet        VS PrintOut.CFGFileName,           Max. vier Buchstaben zum identifizieren des Druck-Jobs
    ;                                                 VN PrintOut.DefaultMode,           IDEAL-Parameter, der normalerweise die Ausgebeart beschreibt
    ;                                                 VN PrintOut.ActualMode             User-Eingabe fr die Ausgabeart (z.B. [RECORD ID2])
    ;
    ;                Uses CARA-Dialog, loads the dialog if needed (uses this BEFORE) the VAR_PRINT is allocated
    ;
    ;
    ;
    ;
    ;                PROCEDURE PrintOut.Direct        VS PrintOut.PrintVar,              Name der Druck-Job-Variablen
    ;                                                 VN PrintOut.Copies,                Anzahl der gewnschten Kopien
    ;                                                 VN PrintOut.DefaultMode,           IDEAL-Parameter, der normalerweise die Ausgebeart beschreibt
    ;                                                 VN PrintOut.ActualMode             User-Eingabe fr die Ausgabeart (z.B. [RECORD ID2])
    ;
    ;                Directly prints aout to the standrad printer or shows the document
    ;
    ;
    ;
    ;
    ;                PROCEDURE PrintOut.eDocPrintPro  VS PrintOut.PrintVar,              Name der Druck-Job-Variablen
    ;                                                 VN PrintOut.Copies,                Anzahl der gewnschten Kopien
    ;                                                 VB PrintOut.ShowMessages,          Sollen Warnmeldungen ausgegeben werden
    ;                                                ~VS PrintOut.eDocPrintProFileName   Name der PDF-Datei, in die "gedruckt" wurde
    ;
    ;                Directly prints to the eDocPrintPro Printer and returns the filename of the pdf-file
    ;



  PROCEDURE PrintOut.CheckAndSetPrinterCfgPath
    LOCAL_BOOL LocRes
    LOCAL_STR  LocPath2Use

;   CALC [LocPath2Use] AS 'c:\temp\'
;   CALC [LocPath2Use] AS [TEMP_FILES_PATH]
    CALC [LocPath2Use] AS [PRINTSET_PATH]

    IDENTIFIER_EXIST 'GlobTempPath',[LocRes]
    IF [LocRes]
      CALC [GlobTempPath] AS [LocPath2Use]
    ELSE
      GLOBAL_STR GlobTempPath, [LocPath2Use]
    END_IF

    EXIST_DIR [GlobTempPath],[LocRes]
    IF [LocRes]=FALSE
      FORCE_DIR [LocRes],[GlobTempPath]
    END_IF
  END_PROC



  PROCEDURE PrintOut.OutPut VS PrintOut.PrintVar, VN PrintOut.Copies, VS PrintOut.CFGFileName, VN PrintOut.DefaultMode, VF PrintOut.ActualMode
    CALL PrintOut.CheckAndSetPrinterCfgPath

    LOCAL_NUM   PrintOut.Mode
    LOCAL_NUM   PrintOut.TmpNum

    CALC [PrintOut.Mode] AS [PrintOut.DefaultMode]
    IF [PrintOut.ActualMode]>[EPSILON]
      CALC [PrintOut.Mode] AS [PrintOut.ActualMode]
    END_IF


    CALC [PrintOut.CFGFileName] AS CON([GlobTempPath],[STATION_SHORT],[PrintOut.CFGFileName],'.pst')
    CALC [PrintOut.CFGFileName] AS LOWCASE([PrintOut.CFGFileName])

    IF [PrintOut.Mode]=[PRINT_OUT_DIRECT]
      PRINT_SET [[PrintOut.PrintVar]], [PrintOut.CFGFileName], FALSE
    ELSE_IF [PrintOut.Mode]=[PRINT_OUT_DIRECT_SETUP]
      LOCAL_BOOL  LocRes
      EXIST_FILE [PrintOut.CFGFileName],[LocRes]
      IF [LocRes]
        FILE_DELETE [LocRes], [PrintOut.CFGFileName]
      END_IF

      PRINT_SET [[PrintOut.PrintVar]], [PrintOut.CFGFileName], TRUE
    END_IF

    PROCESS_MESSAGES

    IF [PrintOut.Mode]<>[PRINT_OUT_PREVIEW]
      IF [PrintOut.Copies]<=0
        CALC [PrintOut.Copies] AS 1
      END_IF

      CALC [PrintOut.TmpNum] AS 1
      WHILE [PrintOut.TmpNum]<=[PrintOut.Copies]
        PRINT_OUT  [[PrintOut.PrintVar]], [PRINT_OUT_DIRECT]
        INC [PrintOut.TmpNum]
      END_WHILE
    ELSE
      PRINT_OUT  [[PrintOut.PrintVar]], [PRINT_OUT_PREVIEW]
    END_IF
  END_PROC



  PROCEDURE PrintOut.GetSet VS PrintOut.CFGFileName, VN PrintOut.DefaultMode, VF PrintOut.ActualMode, VS PrintOut.SetupMessage, VB PrintOut.HideMessages
    CALL PrintOut.CheckAndSetPrinterCfgPath

    LOCAL_NUM   PrintOut.Mode
    LOCAL_NUM   PrintOut.TmpNum
    LOCAL_NUM   PrintOut.Dummy
    LOCAL_BOOL  PrintOut.Res
    LOCAL_STR   PrintOut.Str
    LOCAL_STR   PrintOut.TmpStr

    CALC [PrintOut.Mode] AS [PrintOut.DefaultMode]
    IF [PrintOut.ActualMode]>[EPSILON]
      CALC [PrintOut.Mode] AS [PrintOut.ActualMode]
    END_IF

    IF [PrintOut.Mode]=[PRINT_OUT_PREVIEW]
      EXIT_PROC
    END_IF

    IF [PrintOut.Mode]>[SEND_OUT_CHAT]
      CALC [PrintOut.CFGFileName] AS CON([GlobTempPath],[STATION_SHORT],[PrintOut.CFGFileName],'_',[PrintOut.Mode],'.pst')
      CALC [PrintOut.CFGFileName] AS LOWCASE([PrintOut.CFGFileName])

      CALC [PrintOut.TmpStr]      AS CON([PrintOut.CFGFileName],'d')
      EXIST_FILE [PrintOut.TmpStr],[PrintOut.Res]
      IF [PrintOut.Res]
        CALC [PrintOut.Mode] AS [PRINT_OUT_DIRECT]
      ELSE
        CALC [PrintOut.Mode] AS [PRINT_OUT_DIRECT_SETUP]
      END_IF
    ELSE
      CALC [PrintOut.CFGFileName] AS CON([GlobTempPath],[STATION_SHORT],[PrintOut.CFGFileName],'.pst')
    END_IF

    CALC [PrintOut.CFGFileName] AS LOWCASE([PrintOut.CFGFileName])

    IF [PrintOut.HideMessages]=FALSE
      WAIT_INFO 'Druckerausgabe fr', [PrintOut.SetupMessage]
    END_IF

    IF [PrintOut.Mode]=[PRINT_OUT_DIRECT]
      PRINT_SET [PrintOut.Dummy], [PrintOut.CFGFileName], 1, TRUE
    ELSE_IF [PrintOut.Mode]=[PRINT_OUT_DIRECT_SETUP]
      IF [PrintOut.CFGFileName]<>''
        EXIST_FILE [PrintOut.CFGFileName],[PrintOut.Res]
        IF [PrintOut.Res]
          FILE_DELETE [PrintOut.Res], [PrintOut.CFGFileName]
        END_IF

        CALC [PrintOut.Str] AS CON([PrintOut.CFGFileName],'d')
        EXIST_FILE [PrintOut.Str],[PrintOut.Res]
        IF [PrintOut.Res]
          FILE_DELETE [PrintOut.Res], [PrintOut.Str]
        END_IF

        CALC [PrintOut.Str] AS CON([PrintOut.CFGFileName],'s')
        EXIST_FILE [PrintOut.Str],[PrintOut.Res]
        IF [PrintOut.Res]
          FILE_DELETE [PrintOut.Res], [PrintOut.Str]
        END_IF

        PROCESS_MESSAGES
      END_IF

      PRINT_SET [PrintOut.Dummy], [PrintOut.CFGFileName], 2, TRUE
    END_IF

    END_WAIT

    PROCESS_MESSAGES
  END_PROC



  PROCEDURE PrintOut.Direct VS PrintOut.PrintVar, VN PrintOut.Copies, VN PrintOut.DefaultMode, VF PrintOut.ActualMode
    LOCAL_NUM PrintOut.Mode
    LOCAL_NUM PrintOut.TmpNum

    CALC [PrintOut.Mode] AS [PrintOut.DefaultMode]
    IF [PrintOut.ActualMode]>[EPSILON]
      CALC [PrintOut.Mode] AS [PrintOut.ActualMode]
    END_IF

    IF [PrintOut.Mode]<>[PRINT_OUT_PREVIEW]
      IF [PrintOut.Copies]<=0
        CALC [PrintOut.Copies] AS 1
      END_IF

      CALC [PrintOut.TmpNum] AS 1
      WHILE [PrintOut.TmpNum]<=[PrintOut.Copies]
        PRINT_OUT [[PrintOut.PrintVar]], [PRINT_OUT_DIRECT]
        INC [PrintOut.TmpNum]
      END_WHILE
    ELSE
      PRINT_OUT [[PrintOut.PrintVar]], [PRINT_OUT_PREVIEW]
    END_IF
  END_PROC



  PROCEDURE PrintOut.eDocPrintPro VS PrintOut.PrintVar, VN PrintOut.Copies, VB PrintOut.ShowMessages, ~VS PrintOut.eDocPrintProFileName
    LOCAL_STR   PrintOut.FileName
    LOCAL_BOOL  PrintOut.Res

    CALC [PrintOut.eDocPrintProFileName] AS ''

    CALC [PrintOut.FileName] AS CON([CARA_PATH],'eDocPrintProSniffer.exe')
    EXIST_FILE [PrintOut.FileName],[PrintOut.Res]
    IF [PrintOut.Res]=FALSE
      IF [PrintOut.ShowMessages]
        MESSAGE 'Achtung Abbruch','Der "eDocPrintProSniffer" ist nicht installiert.|Das Programm befindet sich nicht im CARA-Verzeichnis!',[MESSAGE_ERROR]
      END_IF
      EXIT_PROC
    END_IF

    LOCAL_STR   PrintOut.Str1
    LOCAL_STR   PrintOut.Str2
    LOCAL_NUM   PrintOut.Cnt
    LOCAL_NUM   PrintOut.Max
    LOCAL_NUM   PrintOut.Ln
    LOCAL_STR   PrintOut.Line
    LOCAL_FLOAT PrintOut.ID
    LOCAL_LIST  PrintOut.Lst

    ACT_REC_ID [PrintOut.ID]
    CALC [PrintOut.FileName] AS CON([PrintOut.FileName],' ',[PrintOut.ID|R0,0])
    EXTERN [PrintOut.FileName], [EXTERN_SHOWNA]

    CALL PrintOut.Direct [PrintOut.PrintVar], [PrintOut.Copies], [PRINT_OUT_DIRECT], [PRINT_OUT_DIRECT]

    CALC [PrintOut.FileName] AS CON([TEMP_FILES_PATH],'eDocPrintProSniffer.log')
    CALC [PrintOut.Cnt] AS 0
    WHILE [PrintOut.Cnt]<=20
      EXIST_FILE [PrintOut.FileName],[PrintOut.Res]
      IF [PrintOut.Res]
        LIST_CLR [PrintOut.Lst]
        LIST_FILE_READ [PrintOut.Lst],[PrintOut.Res],[PrintOut.FileName]
        IF [PrintOut.Res]
          LIST_ITEM_GET [PrintOut.Lst],[PrintOut.Ln],[PrintOut.Max]
          IF [PrintOut.Max]>0
            LIST_STR_GET [PrintOut.Lst],[PrintOut.Line],[PrintOut.Max]
            ; 1    2    3       4       5        6    7
            ; date;time;message;printer;document;path;result;
            ; 2008-26-03;17:22:01;stop;eDocPrintPro;Cara;C:\tmp\eDocPrintProAusgabe.pdf;7849497885351;
            CALC [PrintOut.Str2] AS [PrintOut.ID|R0,0]
            CALC [PrintOut.Str1] AS PART([PrintOut.Line],7,';')

            IF [PrintOut.Str1]=[PrintOut.Str2]
              CALC [PrintOut.Line] AS PART([PrintOut.Line],6,';')
            END_IF

            EXIST_FILE [PrintOut.Line],[PrintOut.Res]
            IF [PrintOut.Res]
              CALC [PrintOut.Cnt] AS 100
              CALC [PrintOut.eDocPrintProFileName] AS [PrintOut.Line]
            END_IF
          END_IF
        END_IF
      ELSE
        DELAY 500
      END_IF
      INC [PrintOut.Cnt]
    END_WHILE

    EXIST_FILE [PrintOut.eDocPrintProFileName],[PrintOut.Res]
    IF [PrintOut.Res]=FALSE
      CALC [PrintOut.eDocPrintProFileName] AS ''
      IF [PrintOut.ShowMessages]
        MESSAGE 'Achtung Abbruch','Die PDF-Datei konnte nicht erzeugt oder gefunden werden',[MESSAGE_ERROR]
      END_IF
      EXIT_PROC
    END_IF
  END_PROC


